package brain.alice;

/*
 * Created on Jul 30, 2004
 *
 * This is the interfce to the ALICE like engine - the Program D
 * It is assumed this is only a interface and the ALICE it sel will have to be stripped and recoded in order to be abel to do energetic classification. 
 */


import java.awt.event.ActionEvent;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.PrintStream;
import java.util.StringTokenizer;

import javax.swing.JTextArea;

import mns.BioDeviceEvent;
import mns.MNSEvent;
import nns.BioSensor;
import nns.BioSensorEvent;

import org.alicebot.server.core.Globals;
import org.alicebot.server.core.util.Shell;
import org.alicebot.server.core.util.Trace;
import org.alicebot.server.net.AliceServer;

import brain.NetClient.RobotClientEvent;
import brain.NetClient.RobotClientListener;

//import com.mysql.jdbc.Messages;


/**
 * 
 * @author martin
 *
 */
public class AliceBasedInterface extends BioSensor {

	/* (non-Javadoc)
	 * @see nns.BioSensorListener#sensorPercieved(nns.BioSensorEvent)
	 */
	public void sensorPercieved(BioSensorEvent event) {
		String instr = event.getEventString();
		if (instr.indexOf("M") > -1) //$NON-NLS-1$
			instr = instr.substring(instr.indexOf(" ")); //$NON-NLS-1$
		if (instr.indexOf('*') > 0) {
			String bot = instr.substring(0, instr.indexOf('*'));
			instr = instr.substring(instr.indexOf('*') + 1);
			String command = instr.substring(0, instr.indexOf('*'));
			instr = instr.substring(instr.indexOf('*') + 1);
			if (bot.trim().equalsIgnoreCase("mouth")) //$NON-NLS-1$
				bot = "speech"; //$NON-NLS-1$
			inStream.receive("/talkto " + bot); //$NON-NLS-1$
			try{
				sleep(200);
			}catch (Exception e){
				
			}
			inStream.receive(command + " " + instr); //$NON-NLS-1$
		} else {
			String bot = instr.substring(0, instr.indexOf(' '));
			instr = instr.substring(instr.indexOf('0') + 1);
			String command = instr.substring(0, instr.indexOf('0'));
			instr = instr.substring(instr.indexOf('0') + 1);
			inStream.receive("/talkto " + bot); //$NON-NLS-1$
			try{
				sleep(200);
			}catch (Exception e){
				
			}
			inStream.receive(command + " " + instr); //$NON-NLS-1$
		}
	}

	/* (non-Javadoc)
	 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
	 */
	public void actionPerformed(ActionEvent ae) {
		String inputText = ae.getActionCommand();
		if (inputText.indexOf("/load") != -1){ //$NON-NLS-1$
			String file = inputText.substring(inputText.lastIndexOf(" ")); //$NON-NLS-1$
			if (bot.toLowerCase().trim() == "speech" || bot.toLowerCase().trim() == "voice") //$NON-NLS-1$ //$NON-NLS-2$
				file = "/load "+configFilesRoot+"/standard/"+file.trim(); //$NON-NLS-1$ //$NON-NLS-2$
			else
				file = "/load "+configFilesRoot+"/standard/"+bot.toLowerCase()+"/"+file.trim(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			
			inStream.receive(file);
			return;
		}
			
		inStream.receive(inputText);
		display.append(inputText + LINE_SEPARATOR);
		//input.setText(null);
	}

	/* (non-Javadoc)
	 * @see mns.MNSListener#process(mns.MNSEvent)
	 */
	public void process(MNSEvent cnv) {
		inStream.receive((String)cnv.getData());
	}

	public AliceBasedInterface(JTextArea display, RobotClientListener listener) {
		super(1, "alice"); //$NON-NLS-1$
		this.display = display;
		this.listener = listener;

	}

	public AliceBasedInterface(RobotClientListener listener) {
		super(1, "alice"); //$NON-NLS-1$
		this.listener = listener;

	}

	public void addDisplay(JTextArea display) {
		this.display = display;
	}

	public void run() {
		displayStream = new PrintStream(consoleDisplay);
		promptStream = new PrintStream(new ConsolePromptStream());
		inStream = new ConsoleInputStream();

		Globals.load(serverPropertiesPath);
		shell = new Shell(inStream, displayStream, promptStream);
		server = new AliceServer(serverPropertiesPath, this.shell);
		Trace.setOut(displayStream);
		server.startup();
		shutdown();
		System.out.println("ready to go"); //$NON-NLS-1$
	}

	protected void shutdown() {
		if (server != null) {
			AliceServer.shutdown();
		}
		// Let the user exit, in case termination was abnormal or messages are otherwise interesting.
	}

	/**
	 *  Extends OutputStream to direct all output to the display textarea.
	 */
	public class ConsoleDisplayStream extends OutputStream {
		private boolean paused = false;

		public ConsoleDisplayStream() {
			super();
		}

		public void write(byte[] b, int off, int len) {
			while (paused) {
				try {
					Thread.sleep(500);
				} catch (InterruptedException e) {
				}
			}
			if (display != null) {
				display.append(new String(b, off, len));
				display.setCaretPosition(display.getText().length());
			}
			processData(new String(b, off, len));
		}

		public void write(int b) {
			while (paused) {
				try {
					Thread.sleep(500);
				} catch (InterruptedException e) {
				}
			}
			if (display != null) {
				display.append(String.valueOf((char) b));
				display.setCaretPosition(display.getText().length());
			}

			processData(String.valueOf((char) b));
		}

		private void togglePause() {
			paused = !paused;
		}
	}

	/**
	 * @return Returns the active.
	 */
	public boolean isActive() {
		return active;
	}
	/**
	 * @param active The active to set.
	 */
	public void setActive(boolean active) {
		this.active = active;
	}
	/**
	 * @return Returns the mood.
	 */
	public String getMood() {
		return mood;
	}
	/**
	 * @param mood The mood to set.
	 */
	public synchronized void setMood(String mood) {
		System.out.println("Setting mood to: "+mood); //$NON-NLS-1$
		if (this.mood != "0") //$NON-NLS-1$
			return;
		this.mood = mood;
		if (mood == "happy")  //$NON-NLS-1$
			listener.clientCommand(new RobotClientEvent(
				"robot*enregy*" + "50")); //$NON-NLS-1$ //$NON-NLS-2$
		else if (mood == "angry") //$NON-NLS-1$
			listener.clientCommand(new RobotClientEvent(
					"robot*enregy*" + "100")); //$NON-NLS-1$ //$NON-NLS-2$
		else 		listener.clientCommand(new RobotClientEvent(
				"robot*enregy*" + "80")); //$NON-NLS-1$ //$NON-NLS-2$

		for (int a = 0; a< bots.length; a++){
				String file = mood+".aiml"; //$NON-NLS-1$
				if (bots[a].toLowerCase().trim() == "speech" || bots[a].toLowerCase().trim() == "voice") //$NON-NLS-1$ //$NON-NLS-2$
					file = "/load "+configFilesRoot+"/standard/voice/"+file.trim(); //$NON-NLS-1$ //$NON-NLS-2$
				else
					file = "/load "+configFilesRoot+"/standard/"+bots[a].toLowerCase()+"/"+file.trim(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
				
				inStream.receive("/talkto "+bots[a]); //$NON-NLS-1$
				inStream.receive(file);
				
				try{
					sleep(200);
				} catch (Exception e){
					
				System.out.println("mood to Bot "+bots[a]+" : "+mood); //$NON-NLS-1$ //$NON-NLS-2$
				}

		}
	}
		
		public synchronized void setMood(int who, String whoo) {
			if (this.mood == "0") //$NON-NLS-1$
				return;
		System.out.println("Setting mood to: "+mood); //$NON-NLS-1$
				String file = this.mood+".aiml"; //$NON-NLS-1$
				if (whoo.toLowerCase().trim() == "speech" || whoo.toLowerCase().trim() == "voice") //$NON-NLS-1$ //$NON-NLS-2$
					file = "/load "+configFilesRoot+"/standard/voice/"+file.trim(); //$NON-NLS-1$ //$NON-NLS-2$
				else
					file = "/load "+configFilesRoot+"/standard/"+whoo.toLowerCase()+"/"+file.trim(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
				
				inStream.receive("/talkto "+whoo); //$NON-NLS-1$
				try{
					sleep(200);
				}catch (Exception e){
					
				}
				inStream.receive(file);
				System.out.println("mood to Bot "+whoo+" : "+mood); //$NON-NLS-1$ //$NON-NLS-2$

		}

	//add mmore code in order to accomodate three main bots at least
	//TODO speech,motion,states
	private void processData(String data) {
		if (active) {
			//System.out.println(" Original: " + data); //$NON-NLS-1$
			data = data.substring(data.indexOf(']') + 1);
			String fromUsr;
			try {
				fromUsr = data.substring(0, data.indexOf('>'));
				//each time set up the bot name
				bot = fromUsr.trim().toLowerCase();
				data = data.substring(data.indexOf('>') + 1);
				data = data.trim();
				//System.out.println(fromUsr + "  " + data); //$NON-NLS-1$
				if (data.length() > 1) {
					//send the data from ALICE either to mouth
					if (fromUsr.trim().toLowerCase().startsWith("voice") //$NON-NLS-1$
							|| fromUsr.trim().toLowerCase()
									.startsWith("speech")) //$NON-NLS-1$
						listener.clientCommand(new RobotClientEvent(
								"mouth*speak*" + data.trim())); //$NON-NLS-1$
					else {
						// or generate a complete motor command
						listener.clientCommand(new RobotClientEvent(fromUsr
								+ "*" + data.substring(0, data.indexOf(' ')) //$NON-NLS-1$
								+ "*" + data.substring(data.indexOf(' ')))); //$NON-NLS-1$
					}

				}
			} catch (StringIndexOutOfBoundsException e) {
				data = data.substring(data.indexOf('>') + 1);
				//System.out.println("  " + data); //$NON-NLS-1$
			}

		}
		//the control sequence comes here
		else{
			if (mood == "0"){ //$NON-NLS-1$
				data = data.substring(data.indexOf("]")+1); //$NON-NLS-1$
				if (data.trim().toLowerCase().startsWith("acti")){ //$NON-NLS-1$
					String bos = data.substring(data.indexOf(':')+1);
					bos.trim();
					StringTokenizer t = new StringTokenizer(bos, " "); //$NON-NLS-1$
					bots = new String[t.countTokens()];
					int i = 0;
					while (t.hasMoreTokens()){
						bots[i] = (String)t.nextElement();
						i++;
					}
				}
				//System.out.println("Bots registered and they are: "+bots.length); //$NON-NLS-1$
			}
	
			
		}
	}

	/**
	 *  Extends OutputStream to direct all output to the prompt field.
	 */
	public class ConsolePromptStream extends OutputStream {
		public ConsolePromptStream() {
			super();
		}

		public void write(byte[] b, int off, int len) {
			//display.append(new String(b, off, len));
		}

		public void write(int b) {
			//display.append(String.valueOf((char) b));
		}
	}

	public class ConsoleInputStream extends InputStream {
		byte[] content = new byte[] {};

		private int mark = 0;

		public ConsoleInputStream() {
		}

		public void receive(String string) {
			content = (string + '\n').getBytes();
			mark = 0;
		}

		public int read(byte b[], int off, int len) throws IOException {
			while (mark >= content.length) {
				synchronized (this){
				try {
					this.wait(100);
				} catch (InterruptedException e) {
					return -1;
				}
				} 	
			}
			if (b == null) {
				throw new NullPointerException();
			} else if ((off < 0) || (off > b.length) || (len < 0)
					|| ((off + len) > b.length) || ((off + len) < 0)) {
				throw new IndexOutOfBoundsException();
			} else if (len == 0) {
				return 0;
			} else if (content.length == 0) {
				return -1;
			}

			int i = 1;
			b[off] = content[mark++];
			for (; i < len && i < content.length; i++) {
				b[off + i] = content[mark++];
			}
			return i;
		}

		public int available() throws IOException {
			return content.length - mark - 1;
		}

		public boolean markSupported() {
			return false;
		}

		public int read() {
			while (mark >= content.length) {
				try {
					this.wait(100);
				} catch (InterruptedException e) {
					return -1;
				}
			}
			if (mark < content.length) {
				return content[mark++];
			} else {
				return -1;
			}
		}

	}

	private String serverPropertiesPath = ("/home/nabhoth/workspace/CoL/alice/server.properties"); //$NON-NLS-1$

	private String configFilesRoot = ("/home/nabhoth/workspace/CoL/alice/aiml"); //$NON-NLS-1$
	
	private JTextArea display;

    private String[] bots;

    /** The server associated with this console. */
	protected AliceServer server;

	/** The Shell used by this console. */
	protected Shell shell;

	private RobotClientListener listener;

	private String mood = "normal"; //$NON-NLS-1$
	
	private String bot = ""; //$NON-NLS-1$

	private boolean active = true;

	private ConsoleDisplayStream consoleDisplay = new ConsoleDisplayStream();

	/** The stream to which console display will be directed. */
	private PrintStream displayStream;

	/** The stream to which console prompt will be directed. */
	private PrintStream promptStream;

	/** The stream which will receive console input. */
	private ConsoleInputStream inStream;

	/** Contains the input prompt and field. */
	//private InputPanel inputPanel;
	/** For convenience, the system line separator. */
	private static final String LINE_SEPARATOR = System.getProperty(
			"line.separator", "\n"); //$NON-NLS-1$ //$NON-NLS-2$

}