/************************************************************************
 * 
 * Created on Jan 6, 2006
 * Package brain.moodconroller
 * Filename MemoryRegister.java
 * 
 ************************************************************************/

//***********************************************************************
//																		*
// Martin Lukac, 2003-2005 												*
// Intelligent Robotics Laboratory										*
// Portland State University 											*
// Office: 70-08 FAB, phone: 503-490-8478								*
// Mail:	P.O. Box 751												*
//			Portland, OR 97207-0751										*
// Email:	lukacm@cecs.pdx.edu											*
// Updates and documentation: 	www.pdx.edu\~lukacm						*
// **********************************************************************
//
//			*********************************************
//			*********************************************
// This program is provided WITHOUT ANY WARRANTY either expressed
// or implied.  You may study, use, modify, and distribute it for
// any non-commercial purposes.  For any commercial use, prior 
// permission from the authors must be granted.
// 			*********************************************
//			*********************************************

package brain.moodconroller;

import java.util.Vector;

import mainframe.Tools;


/**
 * @author nabhoth
 *
 */
public class MemoryRegister extends MemoryUnit{

    /**
     * 
     */
    public MemoryRegister(String register) {
        super(register.substring(register.indexOf('*', 0)));
        Object [] reg = Tools.tokenize(register, "*");
        Vector regster = new Vector();
        //parse the register in associative memory
        this.register = new Vector();
        for (int a = 0;a < reg.length; a++){
            addData(reg[a]);
        }
    }

    /**
     * 
     */
    public MemoryRegister(Object [] register) {
        super((String)register[0]);
        //parse the register in associative memory
        this.register = new Vector();
        for (int a = 0;a < register.length; a++){
            addData(register[a]);
        }
        
    }

    /**
     * @param o
     */
    private void addData(Object o){
        String in = (String)o;
        in = in.trim();
        if (in.indexOf(' ') < 0){
                register.add(new MemorySlot(in));
        }else {
            int a = 0;
            String param = in.substring(a);
            while(a < param.length()){           
                a = param.indexOf(0, ' ');
                if (a > 0)
                    register.add(new MemorySlot(param.substring(0, param.indexOf(0, ' '))));
                else
                    break;
                param = param.substring(a+1);
            }
        }
    }
    /**
     * Comment for <code>register</code>
     */

    
	private Vector register;
}
