/*
 * Created on Aug 30, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package brain.reflexgenerator;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.event.ActionEvent;
import java.awt.image.BufferedImage;
import java.awt.image.DataBuffer;

import javax.swing.BorderFactory;
import javax.swing.JPanel;

import mns.BioDevice;
import mns.BioDeviceListener;
import mns.MNSEvent;
import monitors.CommCenter;
import nns.BioSensor;
import nns.BioSensorEvent;
import nns.BioSensorListener;
import devs.visionpackage.org.cmotch.imageviewer.ImagePanel;

/**
 * @author nabhoth
 * 
 */
public class PMotionCalculator extends BioSensor {
    
    /*
     * (non-Javadoc)
     * 
     * @see mns.BioDevice#addListener(mns.BioDeviceListener)
     */
    public void addListener(BioDeviceListener rP) {
        // BioSensor.addListener(rP);
        this.listener = rP;
        
    }
    
    /*
     * (non-Javadoc)
     * 
     * @see mns.BioDevice#getControls()
     */
    public String getControls() {
        return null;
    }
    
    BioDeviceListener listener = null;
    
    // private BufferedImage inImg;
    // private BufferedImage motionImage;
    private DataBuffer buffer = null;
    
    private int[][][] detector = new int[160][120][3];
    
    private int[][] motion = new int[160][120];
    
    private int[] coordinatesBase = new int[2];
    
    int baseCounter = 0;
    
    int motionCounter = 0;
    
    private int[] coordinatesMotion = new int[2];
    
    public static int MEM_STEP = 10;
    
    public static int DETECT_LIMIT = (2 << 19);
    
    public static int RGB_DETECT_LIMIT = 250;
    
    private ImagePanel ip = null;
    
    private JPanel id = null;
    
    public static int NO_STEP = 0;
    
    public static int N_STEP = 7;
    
    public static int E_STEP = 3;
    
    public static int W_STEP = 6;
    
    public static int S_STEP = 5;
    
    public static int NE_STEP = 10;
    
    public static int NW_STEP = 13;
    
    public static int SE_STEP = 8;
    
    public static int SW_STEP = 11;
    
    public static String[] nGenSteps = { "NO_STEP", "", "", "E_STEP", "",
        "S_STEP", "W_STEP", "N_STEP", "SE_STEP", "", "NE_STEP", "SW_STEP",
        "", "NW_STEP" };
    
    public static int[] genSteps = new int[2];
    
    /**
     * @param listener
     */
    public PMotionCalculator(BioSensorListener listener) {
        super(EXTERO_SENSOR, "motionsensor");
        addListener(listener);
    }
    
    /**
     * @param ip -
     *            the initial display
     * @param listener -
     *            the listener
     */
    public PMotionCalculator(ImagePanel ip, BioSensorListener listener) {
        super(EXTERO_SENSOR, "motionsensor");
        this.ip = ip;
        
        addListener(listener);
        this.start();
    }
    
    /**
     * @param ip
     * @param id
     * @param listener
     */
    public PMotionCalculator(ImagePanel ip, JPanel id,
            BioSensorListener listener) {
        super(EXTERO_SENSOR, "motionsensor");
        this.ip = ip;
        this.id = id;
        this.id.setBorder(BorderFactory.createTitledBorder(BorderFactory
                .createLoweredBevelBorder(), "Motion Detector"));
        
        addListener(listener);
        // initiate the id Panel for direction indication
        Graphics g = this.id.getGraphics();
        g.drawString("hello", id.getWidth() / 2, id.getHeight() / 2);
        g.dispose();
        // id.repaint();
        this.start();
    }
    
    /**
     * @return Returns the ip.
     */
    public synchronized ImagePanel getIp() {
        return ip;
    }
    
    /**
     * @param bi -
     *            extract the data from the taken image
     */
    synchronized public void setData(BufferedImage bi) {
        motion = new int[160][120];
        buffer = bi.getData().getDataBuffer();
        for (int x = 0; x < detector.length; x++) {
            for (int y = 0; y < detector[0].length; y++) {
                int t = bi.getRGB(x, y);
                // t = (int) ((t & 0x101010));
                t = (int) ((t & 0xA0A0A0));
                if (t > RGB_DETECT_LIMIT) {
                    motion[x][y] = 1;
                } else
                    motion[x][y] = 0;
            }
        }
        notify();
    }
    
    /*
     * (non-Javadoc)
     * 
     * @see java.lang.Runnable#run()
     */
    public void run() {
        int steps = 0;
        long messtime = System.currentTimeMillis();
        while (true) {
            synchronized (this) {
                try {
                    wait(50);
                } catch (InterruptedException e) {
                    e.printStackTrace();
                }
                // analyze the picture and add it
                // each steps%MEM_STEPS steps erase the memory
                if (steps % MEM_STEP == 0) {
                    setInit();
                } else {
                    coordinatesMotion = new int[2];
                    motionCounter = 0;
                    for (int x = 1; x < detector.length - 1; x++) {
                        for (int y = 1; y < detector[0].length - 1; y++) {
                            // motion detected
                            // if (detector[x][y][0] == 0 & motion[x][y] != 0) {
                            if (motion[x][y] != 0) {
                                coordinatesMotion[0] += x;
                                coordinatesMotion[1] += y;
                                motionCounter++;
                                
                                // detector[x][y][2] = detector[x][y][2]
                                // % genSteps.length;
                                // genSteps[detector[x][y][2]] =
                                // genSteps[detector[x][y][2]] + 1;
                                detector[x][y][0] = detector[x][y][0]
                                                                   | motion[x][y];
                            }
                            
                        }
                    }
                    if (motionCounter != 0) {
                        coordinatesMotion[0] /= motionCounter;
                        coordinatesMotion[1] /= motionCounter;
                        
                        int coordx = coordinatesMotion[0] - coordinatesBase[0];
                        int coordy = coordinatesMotion[1] - coordinatesBase[1];
                        
                        // one percent of the total pixels error
                        int errTolerance = 5;
                        
                        // motion to the right
                        if (coordx > errTolerance) {
                            genSteps[0] = E_STEP;
                            // motion to the left
                        } else if (coordx < -errTolerance) {
                            genSteps[0] = W_STEP;
                            // no x motion
                        } else {
                            genSteps[0] = NO_STEP;
                        }
                        // motion to the top
                        if (coordy > errTolerance) {
                            genSteps[1] = N_STEP;
                            // motion to the bottom
                        } else if (coordy < -errTolerance) {
                            genSteps[1] = S_STEP;
                            // no x motion
                        } else {
                            genSteps[1] = NO_STEP;
                        }
                    } else {
                        genSteps[0] = NO_STEP;
                        genSteps[1] = NO_STEP;
                    }
                    
                    setVisual(detector);
                    if ((System.currentTimeMillis() - messtime) / 1000 > 1) {
                        setVisual("By majority the motion is: "
                                + nGenSteps[genSteps[0] + genSteps[1]] + " :: "
                                + genSteps[0] + genSteps[1]);
                        messtime = System.currentTimeMillis();
                    }
                    // add listener
                    CommCenter.showDebug("By majority the motion is: "
                            + nGenSteps[genSteps[0] + genSteps[1]] + " :: "
                            + genSteps[0] + genSteps[1]);
                    if (getListener() != null)
                        getListener().sensorPercieved(
                                new BioSensorEvent("motion sensor", Integer
                                        .toString(genSteps[0] + genSteps[1])));
                }
                steps++;
            }
        }
        
    }
    
    /**
     * initialize the memory for a new detection sequence
     */
    private synchronized void setInit() {
        // coordinates of the initial gravity center
        coordinatesBase = new int[2];
        genSteps = new int[2];
        detector = new int[160][120][3];
        // count the cells counted into the gravity center
        baseCounter = 0;
        for (int x = 0; x < detector.length; x++)
            for (int y = 0; y < detector[0].length; y++) {
                detector[x][y][0] = detector[x][y][0] | motion[x][y];
                if (detector[x][y][0] != 0) {
                    coordinatesBase[0] += x;
                    coordinatesBase[1] += y;
                    baseCounter++;
                }
                detector[x][y][1] = NO_STEP;
            }
        // get the mean
        if (baseCounter != 0) {
            coordinatesBase[0] /= baseCounter;
            coordinatesBase[1] /= baseCounter;
        }
        
    }
    
    /**
     * @param detector -
     *            send the calculated image to the output
     */
    private synchronized void setVisual(int[][][] detector) {
        int counter = 0;
        BufferedImage b = new BufferedImage(160, 120,
                BufferedImage.TYPE_INT_RGB);
        for (int x = 0; x < detector.length; x++)
            for (int y = 0; y < detector[0].length; y++) {
                int d = 0;
                if (detector[x][y][0] != 0)
                    d = (int) ((2 << detector[x][y][1] | 0xFFFFFF));
                b.setRGB(x, y, d);
                counter++;
            }
        if (ip != null)
            ip.setImage(b);
        
    }
    
    private synchronized void setVisual(String mess) {
        // System.out.println(id);
        if (id != null) {
            Graphics g = id.getGraphics();
            
            int x = id.getWidth();
            int y = id.getHeight();
            // add the letter width factor
            int writable = (x - x / 3) / 8;
            int lines = mess.length() / writable;
            // System.out.println(mess.length()+" "+writable+" "+lines+ "
            // "+mess.length()/writable);
            if (lines > 0)
                for (int a = 0; a <= lines; a++) {
                    if (((a + 1) * writable) > mess.length()) {
                        g.setColor(Color.GRAY);
                        g.fillRect(x / 3, (60 + (a - 1) * 20), x / 3, 20);
                        g.setColor(Color.BLACK);
                        g.drawString(mess
                                .substring(a * writable, mess.length()), x / 3,
                                (55 + a * 20));
                    } else
                        g.drawString(mess.substring(a * writable,
                                ((a + 1) * writable)), x / 3, (55 + a * 20));
                }
            else
                g.drawString(mess, id.getWidth() / 3, id.getHeight() / 2);
            g.dispose();
        }
    }
    
    /**
     * @param ip
     *            The associated panel to set.
     */
    public synchronized void setIp(ImagePanel ip) {
        this.ip = ip;
        notify();
    }
    
    /*
     * (non-Javadoc)
     * 
     * @see nns.BioSensor#process(mns.MNSEvent)
     */
    public void process(MNSEvent cnv) {
        String data = (String) cnv.getData();
        if (data.indexOf('*') >= 0) {
            data = data.substring(data.indexOf('*') + 1);
        }
        if (data.startsWith("start") || data.startsWith("dance")) {
            this.seState(BioDevice.BUSY);
        } else if (data.startsWith("stop")) {
            this.seState(BioDevice.DONE);
        }
    }
    
}
