package qcnn;

//import fourier.window.DiscreteFourierTransform;

// Pecep.java
//
// has only one hidden layer

public class QPecep {

	/**
	 * @param entry
	 */
	public double[] In(double[] entry) {
		for (int i = 0; i < inlength.length; i++) {
			inlength[i] = entry[i];
			lastInput[i] = entry[i];
		}
		
		//layer propagating through 
		for (int a = 0; a < hidlengt.length; a++) {
			hidlengt[a][0] = 0;
			for (int b = 0; b < inlength.length; b++) {
				hidlengt[a][0] += inlength[b] * inconex[a][b];
			}
			hidlengt[a][0] = eval(hidlengt[a][0]);
			hidlengt[a][1] = dsigmoid(hidlengt[a][0]);
		}

		//normalizing data
		complex[] normpercept = new complex[percept.length];
		for (int a = 0; a < hidlengt.length; a++) {
			normpercept[a] = new complex(hidlengt[a][0],0);///percept.length; 
		}
		
		//the comnplex addon
		complex [] fft = FastFT.fft(normpercept);
		double max = 0.0;
		for (int a = 0; a < fft.length; a++){
			max += fft[a].modulusSquared();
		}

        //generating probability occurences
        //represented by rank vector (integer coefficients)
		int rankh [] = new int[fft.length];
		for (int a = 0; a < wavePeriod; a++){
			int m = FastFT.getMeasured(max, fft);
			if (m < rankh.length)
				rankh[m]++;
		}
		
		//layer propagating through 
		for (int b = 0; b < outlengt.length; b++) {
			outlengt[b][0] = 0;
			for (int c = 0; c < hidlengt.length; c++) {
				outlengt[b][0] += outconex[b][c] * hidlengt[c][0];
			}
			outlengt[b][0] = eval(outlengt[b][0]);
			outlengt[b][1] = dsigmoid(outlengt[b][0]);
			percept[b] = outlengt[b][0];
		}

		//normalizing data
		normpercept = new complex[percept.length];
		for (int a = 0; a < percept.length; a++) {
			normpercept[a] = new complex(outlengt[a][0],0);///percept.length; 
		}

		//the comnplex addon
		complex [] ffto = FastFT.fft(normpercept);
		double maxo = 0.0;
		for (int a = 0; a < fft.length; a++){
			maxo += ffto[a].modulusSquared();
		}
		
        //generating probability occurences
        //represented by rank vector (integer coefficients)
		int rankho [] = new int[ffto.length];
		for (int a = 0; a < wavePeriod; a++){
			int m = FastFT.getMeasured(maxo, ffto);
			if (m < rankho.length)
				rankho[m]++;
		}

		//normalizing the output vector of probabilities
		double result = 0.0;
		double [] out = new double[rankho.length];
		for (int a = 0; a < rankho.length; a++)
			result += Math.pow(rankho[a], 2);
		
		//insering the quatum optimization
		for (int a = 0;a < ffto.length; a++)
			ffto[a].times(1-out[a]);
		//percept[a] *= (1-out[a]);
		complex output [] = FastFT.ifft(ffto);
		return percept;
	}

	/**
	 *  
	 */
	private void Clean() {
		for (int a = 0; a < inlength.length; a++) {
			inlength[a] = 0.0;
		}
		for (int a = 0; a < hidlengt.length; a++) {
			hidlengt[a][0] = 0.0;
			hidlengt[a][1] = 0.0;
		}
		for (int a = 0; a < outlengt.length; a++) {
			outlengt[a][0] = 0.0;
			outlengt[a][1] = 0.0;
		}
	}

	/**
	 * @param entry
	 * @return
	 */
	private double eval(double entry) {
		if (function == "sig")
			return sigmoid(entry);
		else
			return gauss(entry);
	}

	/**
	 * @param entry
	 * @return
	 */
	public double sigmoid(double entry) {
		return 1 / (1 + Math.exp(-2 * entry));
	}

	/**
	 * @param entry
	 * @return
	 */
	public double dsigmoid(double entry) {
		return (1 - entry) * entry;
	}

	/**
	 * @param entry
	 * @return
	 */
	public double gauss(double entry) {
		return Math.exp((-Math.pow(entry, 2) / 2));
	}

	//normalized given set of coefficients and return a new set of coefficients
	/**
	 * @param data
	 * @return
	 */
	private double[] normalize(double[] data) {
		double dummy = 0;
		double result[] = new double[data.length];
		for (int a = 0; a < data.length; a++) {
			result[a] = Math.pow(data[a], 2);
			dummy += result[a];
		}
		//the coefficients are normalized
		if (dummy == 1)
			return result;

		dummy = result.length / dummy;

		for (int a = 0; a < result.length; a++) {
			result[a] = Math.sqrt(result[a] * dummy / result.length);
		}
		return result;
	}

	/**
	 * the learn method. takes the error vector as input.
	 * 
	 * @param error
	 */
	public void learn(double[] error) {
		//In(lastInput);
		double[] outerr = new double[error.length];
		double[] hiderr = new double[hidlengt.length];

		for (int a = 0; a < error.length; a++) {
			outerr[a] = 0.5 * error[a] * (1 - Math.pow(outlengt[a][0], 2));
		}
		//calculation of error on hidden layer cells
		for (int a = 0; a < hidlengt.length; a++) {
			hiderr[a] = 0;
			for (int b = 0; b < outlengt.length; b++) {

				hiderr[a] += outconex[b][a] * outerr[b];
			}
			hiderr[a] *= (1 - Math.pow(hidlengt[a][0], 2)) * 0.5;
		}
		//updating weights of connections
		for (int a = 0; a < hidlengt.length; a++)
			for (int b = 0; b < outlengt.length; b++)
				outconex[b][a] += learn * outerr[b] * hidlengt[a][0];
		for (int b = 0; b < inlength.length; b++)
			for (int a = 0; a < hidlengt.length; a++)
				inconex[a][b] += learn * hiderr[a] * inlength[b];
		Clean();
	}

	/**
	 * This sets the decision quantum matrix according to the output - output relation 
	 *
	 */
	private void setEnergy() {
		//Here we need the urier transform for n outputs
	}

	/**
	 * @param x - the input width
	 * @param y - the output width
	 * @param z - hidden width
	 */
	public QPecep(int x, int y, int z) {
		inlength = new double[x];
		lastInput = new double[x];
		hidlengt = new double[z][3];
		outlengt = new double[y][3];
		percept = new double[y];
		inconex = new double[z][x];
		outconex = new double[y][z];
		qmem1 = new Complex[2 ^ z];
		qmem2 = new Complex[2 ^ y];
		Random R = new Random();
		for (int a = 0; a < (z); a++) {
			for (int b = 0; b < x; b++) {
				inconex[a][b] = (2 * R.nextDouble()) - 1;
			}
			for (int c = 0; c < y; c++)
				outconex[c][a] = (2 * R.nextDouble()) - 1;
		}
		midNRG = Emid(x, y);
		f = new Fourier();
		//f.setlength(y);
	}

	/**
	 * @param x
	 * @param y
	 * @return
	 */
	public double Emid(int x, int y) {
		double result = x + (x * 2) + y;
		result += (x * x * 2) + (x * y * 2) * Math.random();
		return result;
	}

	/**
	 * @return
	 */
	public double getNRG() {
		return midNRG;
	}

	private FFT fft;
	
	private Fourier f;
	
	private int wavePeriod = 50;

	private double[] inlength; // input cells

	private double[][] hidlengt; // hidden cells

	private double[][] outlengt; // output cells

	private double[][] inconex; // connections between input and hidden

	private double[][] outconex; // connections between hidden and output

	private double learn = 0.1; // learning rate

	private double[] percept; // perceptive artefact of the percpetron

	private double[] lastInput; // mem of last input vector

	private double midNRG;

	//default mode of functioning is in igmoid activation function
	private String function = "sig";

	
	//for time based mode lets add the current period value
	
	
	//this is the bank that will constitue the quantum helper
	private Complex[] qmem0;
	private Complex[] qmem1;
	private Complex[] qmem2;

}