package crlparser.xiay;

////////////////////////////////////////////////////////////////////////////
//  Name: CRL_Handler.Java
//  The handler of the XML parser
//
//  Author:  Yu Xia
//  Created: 2/15/2004
/////////////////////////////////////////////////////////////////////////////
import crlparser.ParserListener;
import crlparser.ParserEvent;

import org.xml.sax.*;
import org.xml.sax.helpers.DefaultHandler;

 
public class CRL_Handler extends DefaultHandler
{
		// data members
		private String command = null; 		//current element name
		private String robotPart = null;			//we need a address to where send the commands
		
		private String robot_name = "-1";	// the robot name
		private int is_robot_name = 0;		// is currently parsing robot tag?
		
 		private String pattern;		// output command according defined patterns
		private int begin_pattern;	// is the pattern beginning when parsing? 
		private String open_command; //for multiple words command we stack them together
		
		private int output_option = 0;		// class memeber for recording output option
		private CRL_Output_File buff_os;	// output buffer
		private int n_tab = 0;			
		private ParserListener listener;
		
 		public CRL_Handler(String patt, int out_option, CRL_Output_File b_os ) {
			pattern = patt;
			output_option = out_option;
			buff_os = b_os;
		}
 
		public void startElement(String namespaceURL, String localName, 
								String qualifiedName, Attributes atts)
		{
			// check if the pattern we need is begining?
			if(qualifiedName.equalsIgnoreCase(pattern)) {
				begin_pattern = 1;
			}
			
			// check if current tag is <robot>
			if( qualifiedName.equalsIgnoreCase("robot") ) {
				is_robot_name = 1;
			}

			if(begin_pattern == 1) {
					if( qualifiedName.equalsIgnoreCase("robot") ) {
						command = "";
					}
					else if( qualifiedName.equalsIgnoreCase("sync") ) {
						command = "sync";
						robotPart = "";
					} else if( qualifiedName.equalsIgnoreCase("wait") ) {
						command = "wait";
						robotPart = "";
					} else if( qualifiedName.equalsIgnoreCase("eyes") ) {
						robotPart = "eyes";
					} else if( qualifiedName.equalsIgnoreCase("eyebrows") ) {
						robotPart = "eyebrows";
					} else if( qualifiedName.equalsIgnoreCase("mouth") ) {
						robotPart = "mouth";
					} else if( qualifiedName.equalsIgnoreCase("face") ) {
						robotPart = "face";
					} else if( qualifiedName.equalsIgnoreCase("eyelids") ) {
						robotPart = "eyelids";
					} 
										
					else if( qualifiedName.equalsIgnoreCase("move") ) {
						command = "move";
					} else if( qualifiedName.equalsIgnoreCase("move") ) {
						command = "move";
					} else if( qualifiedName.equalsIgnoreCase("normal") ) {
						command = "nomal";
					} else if( qualifiedName.equalsIgnoreCase("left") ) {
						command = "left";
					} else if( qualifiedName.equalsIgnoreCase("speech") ) {
						command = "speech";
					} else if( qualifiedName.equalsIgnoreCase("smile") ) {
						command = "smile";
					} else if( qualifiedName.equalsIgnoreCase("cry") ) {
						command = "cry";
					} else if( qualifiedName.equalsIgnoreCase("div") ) {
						command = "div";
					} else if( qualifiedName.equalsIgnoreCase("sayas") ) {
						command = "sayas";
					} else if( qualifiedName.equalsIgnoreCase("blink") ) {
						command = "blink";
					} else if( qualifiedName.equalsIgnoreCase("emphasis") ) {
						command = "emphasis";
					} else if( qualifiedName.equalsIgnoreCase("mouse") ) {
						command = "mouse";
					} else if( qualifiedName.equalsIgnoreCase("open") ) {
						command = "open";
					} else if( qualifiedName.equalsIgnoreCase("cry") ) {
						command = "cry";
					} else 
						command = "unkown";
						
					if(!command.equals("")) {
						String temp = "\n" + "Robot " + robot_name + ":   " + robotPart + " :  " + command + "      ";
						System.out.print(temp);		
						
						if(output_option == 1) 
							buff_os.save_to_file(temp);
					}
			} 
			
		}
		 
		/*
		This method is called when the SAX parser encounters a close element
		tag. If the person tag is closed, then the person objec must be 
		added to the AddressBook (ab).
		*/
		public void endElement(String namespaceURL, String localName, 
							String qualifiedName) {
			if(qualifiedName.equalsIgnoreCase(pattern)) {
				begin_pattern = 0;
			}
			
//			n_tab--;
		}

	    public void characters(char[] ch, int start, int length)
	    {
			// get the value of within tag
			String temp = "";
			for (int i = start; i < start+length; i++) {
				temp = temp + ch[i];
			}
			 
			if(is_robot_name == 1)  {

				// current tag is the begining with name <robot>
				robot_name = temp;
				System.out.print("\nRobot " + robot_name + " Start to Work ... ");
				//buff_os.save_to_file("\nRobot " + robot_name + " Start to Work ... ");
				is_robot_name = 0;

			} else {
				
				// other tags, not <robot>
				if(begin_pattern == 1) {
					
					// entering the tag with pattern we defined

					if(!temp.trim().equals("")) {
						System.out.print(temp.trim());
						//buff_os.save_to_file(temp.trim());
					} //else
						//System.out.println("");
				}
				
			}
				
		}
	    
	    public void addParserListener(ParserListener listener){
	    	this.listener = listener;
	    }
	   
	    /**
	     * Line is just send back until something else will be added
	     * @param line - string to be parsed 
	     */
	    private String parse(String line) {
	    	if (listener != null)
	    		listener.load(new ParserEvent(line));
	    	return line;
	    }
	    
}
