package crlparser.xiay;

////////////////////////////////////////////////////////////////////////////
//  Name: CRL_Output_File.Java
//  Output commands to a file
//
//  Author:  Yu Xia
//  Created: 2/15/2004
/////////////////////////////////////////////////////////////////////////////

import java.io.*;

public class CRL_Output_File {

	private static FileOutputStream file_os;
	private static BufferedWriter buff_os;
	
	public CRL_Output_File(String file_name) {
		try {
			file_os = new FileOutputStream (file_name);
			buff_os = new BufferedWriter(new OutputStreamWriter(file_os));
		} catch (IOException e) {
			System.out.println("error on creating output file stream");
			System.exit(0);
		}
	}
	
	public  void save_to_file(String str) {
		try {
		//System.out.println("<--" + str + "-->" + buff_os + "-->");
			buff_os.write(str, 0, str.length());
		} catch (IOException e) {
			System.out.println("error on output parsed results to file");
			System.out.println(e.getMessage());
			System.exit(0);
		}
	}

	public void close_file() {
		try {
			buff_os.flush();
		
			file_os.close();
			buff_os.close();
		} catch (IOException e) {
			System.out.println("can not close the output file");
			System.exit(0);
		}
	}
}
