package crlparser.xiay;

////////////////////////////////////////////////////////////////////////////
//  Name: CRL_Parser.Java
//  The parser of the XML file
//
//  Author:  Yu Xia
//  Created: 2/15/2004
/////////////////////////////////////////////////////////////////////////////

import java.io.*;
import org.xml.sax.helpers.DefaultHandler;
import javax.xml.parsers.SAXParserFactory;
import javax.xml.parsers.SAXParser;

class CRL_Parser extends Thread
{
	private CRL_Files crl_files;
	private String file_prefix = "Robot_Temp_";
	private String pattern;
	private int output_option;
	private CRL_Output_File buff_os;
	
	public CRL_Parser(CRL_Files cf, String patt, int output_opt, CRL_Output_File ofile) 
	{
		crl_files = cf;
		pattern = patt;
		output_option = output_opt;
		buff_os = ofile;
		
		//System.out.println(output_option + ", " + buff_os);
	}
	
	public void run() 
	{
		while(true) {
			int file_num = crl_files.get_file_num();
			String file_name = file_prefix + file_num;
			
			if(file_num != -1) {
				//create an documenthandler to create obj model 
				DefaultHandler handler = new CRL_Handler(pattern, output_option, buff_os);
				
				
				SAXParserFactory factory = SAXParserFactory.newInstance();
				try {
					SAXParser saxParser = factory.newSAXParser();
					saxParser.parse(new File(file_name), handler);
				} catch (Throwable t) {
					t.printStackTrace();
				}
			} else 
				return;
		}
	}	
}
