package devs.motorpackage.asc16;
/************************************************************************
 *	Martin Lukac, 2003-2005 		*
 *	Intelligent Robotics Laboratory										*
 *	Portland State University 											*
 *	Office: 70-08 FAB, phone: 503-490-8478								*
 *	Mail:	P.O. Box 751												*
 *			Portland, OR 97207-0751										*
 *	Email:	lukacm@cecs.pdx.edu										*
 *	Updates and documentation: 	www.pdx.edu\~lukacm				*
 ************************************************************************/
//************************************************************************
// * 	This program is provided WITHOUT ANY WARRANTY either expressed
// *	or implied.  You may study, use, modify, and distribute it for
// *	any non-commercial purposes.  For any commercial use, prior 
// *	permission from the authors must be granted.
// ************************************************************************/

/**
 * @author Martin Lukac
 * 
 * This is the interface where the baisc constants define the servo ranges and
 * motion intervals. Writing similar interface is required for every serial/parallel/
 * usb servo controller allowing or not changes to the range and values of parameters  
 * 
 * Practically this will be replaces as soon as a self- or just configuration utility
 * is implemented.
 */

public interface ASC16Listener {

	public void stateChanged();

	
	/**
	 * Maximum position of the servo <code>HIGH_POSITION</code>
	 */
	public static final int HIGH_POSITION = 4000;
	/**
	 * Median position of the servo<code>MIDLE_POSITION</code>
	 */
	public static final int MIDLE_POSITION = 2000;
	/**
	 * Low position of the servo <code>LOW_POSITION</code>
	 */
	public static final int LOW_POSITION = 0;
	/**
	 * Maximum speed and acceleratin of the servo<code>HIGH_SPEED</code>
	 */
	public static final int HIGH_SPEED = 255;
	/**
	 * The median speed of the servo<code>MIDDLE_SPEED</code>
	 */
	public static final int MIDDLE_SPEED = 125;
	/**
	 * Low speed of the servo<code>LOW_SPEED</code>
	 */
	public static final int LOW_SPEED = 1;

	
}
