package devs.motorpackage.miniSSCII;
/**
/************************************************************************
 * 	This program is provided WITHOUT ANY WARRANTY either expressed 		*
 *	or implied.  You may study, use, modify, and distribute it for 		*
 *	any non-commercial purposes.  For any commercial use, prior 		*
 *	permission from the author must be granted.							*
 *	? Jacob D. Biamonte, 2003-2004 Created on Jan 22, 2004				*
 *	Intelligent Robotics Laboratory										*
 *	Portland State University 											*
 *	Office: 70-08 FAB, phone: 503-490-8478								*
 *	Mail:	P.O. Box 751												*
 *			Portland, OR 97207-0751										*
 *	Email:	biamonte@cecs.pdx.edu										*
 *	Updates and documentation: 	www.ece.pdx.edu\~biamonte				*
 ************************************************************************/
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import biocell.BioThread;

/**
 * @author biamonte
 * 
 * To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Generation - Code and Comments
 */
public abstract class Motor extends BioThread implements MotorInterface {

	protected List motorListeners = new ArrayList();

	/*
	 * (non-Javadoc)
	 * 
	 * @see MotorInterface#getCurrentPosition()
	 */
	public abstract int getCurrentPosition();
	/*
	 * (non-Javadoc)
	 * 
	 * @see MotorInterface#rotate(int)
	 */
	public abstract void rotate(int pos);
	/**
	 * @return
	 */
	public abstract int getMotorNumber();

	/*
	 * (non-Javadoc)
	 * 
	 * @see MotorInterface#removeMotorListener(MotorListener)
	 */
	public void removeMotorListener(MotorListener n) {

		this.motorListeners.remove(n);

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see MotorInterface#fireMotorEvent(MotorEvent)
	 */
	public void fireMotorEvent(MotorEvent e) {

		Iterator nListeners = this.motorListeners.iterator();

		while (nListeners.hasNext()) {
			((MotorListener) nListeners.next()).motorReceived(e);
		}
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see MotorInterface#addMotorListener(MotorListener)
	 */
	public void addMotorListener(MotorListener n) {
		this.motorListeners.add(n);

	}

}
