package devs.motorpackage.miniSSCII;
/**
/************************************************************************
 * 	This program is provided WITHOUT ANY WARRANTY either expressed 		*
 *	or implied.  You may study, use, modify, and distribute it for 		*
 *	any non-commercial purposes.  For any commercial use, prior 		*
 *	permission from the author must be granted.							*
 *	? Jacob D. Biamonte, 2003-2004 Created on Jan 18, 2004				*
 *	Intelligent Robotics Laboratory										*
 *	Portland State University 											*
 *	Office: 70-08 FAB, phone: 503-490-8478								*
 *	Mail:	P.O. Box 751												*
 *			Portland, OR 97207-0751										*
 *	Email:	biamonte@cecs.pdx.edu										*
 *	Updates and documentation: 	www.ece.pdx.edu\~biamonte				*
 ************************************************************************/

/**
 * @author biamonte
 * 
 * To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Generation - Code and Comments
 */
public interface MotorInterface {

	/**
	 * Comment for <code>instructionQueue</code>
	 */
	
	/**
	 * @param newPosition
	 *  
	 */
	abstract void rotate(int newPosition);

	/**
	 * @param n
	 */
	abstract void removeMotorListener(MotorListener n);

	/**
	 * @param e
	 */
	abstract void fireMotorEvent(MotorEvent e); 

	/**
	 * @param n
	 */
	abstract void addMotorListener(MotorListener n);

	/**
	 * @return Returns the center position, 127 is defalut in range: 0-254.
	 */
	abstract int getCenterPosition();

	/**
	 * Returns the current position of the Motor: 0-254 default
	 * 
	 * @return int position of current position
	 */
	abstract int getCurrentPosition();

	/**
	 * @return Returns the high position of Motor: 254 default: 0-254.
	 */
	abstract int getHighPosition();

	/**
	 * @return Returns the low position of Motor: 0 default: 0-254.
	 */
	abstract int getLowPosition();

	/**
	 * @return
	 */
	abstract int getNewPosition();



}
