/*
 * Light Development Playlist Editor
 * Copyright (C) 2004 Ulrich Hilger
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package devs.musicpackage;

import javax.swing.AbstractAction;
import java.awt.event.*;
import com.lightdev.app.playlisteditor.PlaylistEditor;
import com.lightdev.app.Application;
import java.util.logging.Level;
import com.lightdev.lib.audio.Player;
import javax.swing.KeyStroke;

/**
* action to stop the item that is currently played
*
* @author Ulrich Hilger
* @author Light Development
* @author <a href="http://www.lightdev.com">http://www.lightdev.com</a>
* @author <a href="mailto:info@lightdev.com">info@lightdev.com</a>
* @author published under the terms and conditions of the
*      GNU General Public License,
*      for details see file gpl.txt in the distribution
*      package of this software as well as any licensing notes
*      inside this documentation
*
* @version 2, September 5, 2004
 */

public class StopPlaybackAction extends AbstractAction {

  /**
   * constructor
   * @param app PlaylistEditor  the application this action belongs to
   */
  public StopPlaybackAction(DanceGenerator app) {
    this.app = app;
    putValue(AbstractAction.ACCELERATOR_KEY, KeyStroke.getKeyStroke(
      KeyEvent.VK_K, KeyEvent.CTRL_MASK));
  }

  /**
   * stop the current play thread
   * @param e ActionEvent  the event that fired this action
   */
  public void actionPerformed(ActionEvent e) {
    Player p = app.getPlayer();
    try {
      if(p != null) {
          System.out.println("stop playing");
          p.stopPlay();
          app.setAnalyzer(null);
      }
    }
    catch(Exception ex) {
        ex.printStackTrace();
      //Application.logStackTrace(ex, getClass());
    }
  }

  /** reference to the application this action belongs to */
  private DanceGenerator app;

}
