package devs.sensorpackage.sonarexplorer;
/**
/************************************************************************
 * 	This program is provided WITHOUT ANY WARRANTY either expressed 		*
 *	or implied.  You may study, use, modify, and distribute it for 		*
 *	any non-commercial purposes.  For any commercial use, prior 		*
 *	permission from the author must be granted.							*
 *	? Jacob D. Biamonte, 2003-2004 Created on Jan 22, 2004				*
 *	Intelligent Robotics Laboratory										*
 *	Portland State University 											*
 *	Office: 70-08 FAB, phone: 503-490-8478								*
 *	Mail:	P.O. Box 751												*
 *			Portland, OR 97207-0751										*
 *	Email:	biamonte@cecs.pdx.edu										*
 *	Updates and documentation: 	www.ece.pdx.edu\~biamonte				*
 ************************************************************************/
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import biocell.BioThread;
import devs.sensorpackage.milford5120.Milford5120;

/**
 * @author biamonte
 * 
 * To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Generation - Code and Comments
 */
public abstract class Sensor extends BioThread{

	protected List motorListeners = new ArrayList();

	/*
	 * (non-Javadoc)
	 * 
	 * @see MotorInterface#getCurrentPosition()
	 */
	public abstract int getCurrentPosition();
	
	/*
	 * (non-Javadoc)
	 * 
	 * @see MotorInterface#getCurrentSpeed(int)
	 */

	public abstract int getCurrentSpeed();
	
	
	/*
	 * (non-Javadoc)
	 * 
	 * @see MotorInterface#rotate(int)
	 */

	public abstract void rotate(int pos);
	
	/*
	 * (non-Javadoc)
	 * 
	 * @see MotorInterface#speed(int)
	 */

	public abstract void setSpeed(int pos);
	
	/**
	 * @return
	 */
	public abstract int getMotorNumber();

	/*
	 * (non-Javadoc)
	 * 
	 * @see MotorInterface#removeMotorListener(MotorListener)
	 */
	public void removeMotorListener(SensorListener n) {

		this.motorListeners.remove(n);

	}

	/**
	 * 
	 */
	public void stateChanged(){
		System.out.println("Servo "+getMotorNumber()+" is done");
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see MotorInterface#fireMotorEvent(MotorEvent)
	 */
	public void fireMotorEvent(SensorEvent e) {

		Iterator nListeners = this.motorListeners.iterator();

		while (nListeners.hasNext()) {
			((SensorListener) nListeners.next()).motorReceived(e);
		}
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see MotorInterface#addMotorListener(MotorListener)
	 */
	public void addMotorListener(SensorListener n) {
		this.motorListeners.add(n);

	}
	
	protected static Milford5120 sensorController = null;  // every servo shares the same motor controller
	protected int currentPosition; 
	protected int highPosition;
	protected int lowPosition; 
	protected int midlePosition; 
	
	protected int newPosition; 
	protected int currentSpeed;
	protected int highSpeed;
	protected int lowSpeed;
	
	protected int newSpeed;
	protected int acceleration;
	protected int motorNumber; // Pin number servo is conected on STAMP

	
	public static final int HIGH_POSITION = 4000;
	public static final int MIDLE_POSITION = 2000;
	public static final int LOW_POSITION = 0;
	//
	public static final int HIGH_SPEED = 100;
	public static final int MIDDLE_SPEED = 50;
	public static final int LOW_SPEED = 0;

}
