/**
 *
 * <p>Title: ImagePanel</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author Chris Motch
 * @version 1.0
 */

package devs.visionpackage.org.cmotch.imageviewer;

import java.awt.*;
import java.awt.image.*;
import javax.swing.*;

/**
 * Define the image panel that will display the output images
 */
public class ImagePanel extends JComponent {

    protected BufferedImage image = new BufferedImage(1, 1,
            BufferedImage.TYPE_INT_RGB);

    /**
     * Get a buffered image from the image panel
     * 
     * @return BufferedImage
     */
    public BufferedImage getImage() {
        return image;
    }

    /**
     * Set the image to be displayed in the image panel
     * 
     * @param image
     *            BufferedImage
     */
    public void setImage(BufferedImage image) {
        this.image = image;
        repaint();
    }

    /**
     * 
     * @param gc
     *            Graphics
     */
    public void paint(Graphics gc) {
        Graphics2D g = (Graphics2D) gc;
        g.drawImage(image, 0, 0, null);
    }

    /**
     * 
     * @return Dimension
     */
    public Dimension getPreferredSize() {
        return new Dimension(image.getWidth(), image.getHeight());
    }
}
