/**
 *
 * <p>Title: MainWindow</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author Chris Motch
 * @version 1.0
 */

package devs.visionpackage.org.cmotch.imageviewer;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.GraphicsEnvironment;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.image.BufferedImage;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyVetoException;
import java.beans.VetoableChangeListener;
import java.util.TimerTask;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JToggleButton;
import javax.swing.WindowConstants;

import mainframe.MIFrame;
import nns.NNS;
import brain.reflexgenerator.PMotionCalculator;
import brain.reflexgenerator.Translator;
import devs.visionpackage.org.cmotch.framegrabber.FrameGrabber;
import devs.visionpackage.org.cmotch.visionlibrary.ColorDetection;
import devs.visionpackage.org.cmotch.visionlibrary.ColorManipulation;
import devs.visionpackage.org.cmotch.visionlibrary.GaussianBlurFilter;

/**
 * Main applet class
 */
public class VisionWindow extends MIFrame implements ActionListener, VetoableChangeListener {
    /* (non-Javadoc)
     * @see java.beans.VetoableChangeListener#vetoableChange(java.beans.PropertyChangeEvent)
     */
    public void vetoableChange(PropertyChangeEvent evt)
            throws PropertyVetoException {
        // TODO Auto-generated method stub

    }
  private JPanel MainPanel = new JPanel();
  private JPanel q = new JPanel();
  private FrameGrabber frameGrab = null;
  private ImagePanel ip = new ImagePanel();
  private ImagePanel detectPanel = new ImagePanel();
  private JPanel decodePanel = new JPanel();
  private DisplayImage displayThread;
  private JComboBox edgeSelector;
  private JLabel fpsLabel=new JLabel();
  private java.util.Timer FPSTimer;
  private NNS nns;

  /**
   * Constructor   *
   */
  public VisionWindow(NNS nns) {
	super(0, 0, "Vision (Control) Panel", true, false);
	super.setSize(new Dimension(550, 450));

    try {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
    this.nns = nns;
  }

  public void actionPerformed(ActionEvent e) {
    JComboBox cb = (JComboBox)e.getSource();
    if (displayThread!=null)
        displayThread.setEdgeType(cb.getSelectedIndex());
  }

  /**
   * Initialize the applet, setting up the panels and populating them with buttons
   */
  private void jbInit() {
      GridBagLayout gbl = new GridBagLayout();
      GridBagConstraints gbc = new GridBagConstraints();
    MainPanel.setLayout(new BorderLayout());
    getContentPane().setLayout(gbl);
    q.setLayout(new GridLayout(0, 1));
    try {
      frameGrab = new FrameGrabber();
      frameGrab.start();
    }
    catch (Exception e) {
      e.printStackTrace();
    }

    q.add(new JButton(actionNewImage()));
    q.add(new JButton(actionStartRTCapture()));
    q.add(new JButton(actionStopRTCapture()));
    q.add(new JButton(actionProcessImage()));
    q.add(new JButton(actionFindEdges()));
    q.add(new JButton(actionConvertBW()));
    q.add(new JButton(actionBlur()));
    edgeSelector=new JComboBox();
    edgeSelector.addActionListener(this);
    edgeSelector.addItem("Sobel Horizontal");
    edgeSelector.addItem("Sobel Vertical");
    edgeSelector.addItem("Roberts Horizontal");
    edgeSelector.addItem("Roberts Vertical");
    edgeSelector.addItem("Prewitt Horizontal");
    edgeSelector.addItem("Prewitt Vertical");
    edgeSelector.addItem("Freichen Horizontal");
    edgeSelector.addItem("Freichen Vertical");
    q.add(edgeSelector);
    q.add(new JToggleButton(actionToggleFindSobelEdges()));
    q.add(new JToggleButton(actionToggleGaussianBlur()));
    q.add(new JToggleButton(actionToggleFindMotion()));
    q.add(new JToggleButton(actionToggleGrayScale()));
    q.add(new JToggleButton(actionToggleBlackWhite()));
    q.add(new JToggleButton(actionToggleColorDetection()));
    q.add(new JToggleButton(actionToggleFindEdges()));
    q.add(fpsLabel);
    fpsLabel.setText("FPS :");
    MainPanel.add(q);
    gbc.fill = GridBagConstraints.BOTH;
    gbc.gridx = 0;
    gbc.gridy = 0;
    gbc.gridheight = 1;
    gbc.gridwidth = 1;
    getContentPane().add(detectPanel, gbc);
    gbc.gridx = 1;
    gbc.gridy = 0;
    gbc.gridheight = 1;
    gbc.gridwidth = 1;
    getContentPane().add(ip, gbc);
    gbc.gridx = 2;
    gbc.gridy = 0;
    gbc.gridheight = 2;
    gbc.gridwidth = 1;
    getContentPane().add(MainPanel, gbc);
    gbc.fill = GridBagConstraints.BOTH;
    gbc.gridx = 0;
    gbc.gridy = 1;
    gbc.gridheight = 1;
    gbc.gridwidth = 2;
    getContentPane().add(decodePanel, gbc);

    ip.setImage(frameGrab.getBufferedImage());
    detectPanel.setImage(new BufferedImage(160,120,BufferedImage.TYPE_INT_RGB));
    decodePanel.setSize(160,120);
  }

  /**
   * main class that starts the application
   * @param title String Title of application
   * @param argv String[] arguments passed into application
   */
  public void main(String title, String[] argv) {
    JFrame frame = new JFrame(title);
    frame.setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
    frame.getContentPane().add(this);

    GraphicsEnvironment ge = GraphicsEnvironment.getLocalGraphicsEnvironment();
    Rectangle r = ge.getMaximumWindowBounds();
    frame.setSize(r.width * 2 / 3, r.height * 2 / 3);
    frame.setLocationRelativeTo(null);

    frame.setVisible(true);
    //start();
  }

  /**
   * capture still image action
   * @return Action
   */
  private Action actionNewImage() {
    return new AbstractAction("Capture Still Image") {
      public void actionPerformed(ActionEvent ev){
        captureImage();
      }
    };
  }

  /**
   * Start Real time capture action
   * @return Action
   */
  private Action actionStartRTCapture() {
    return new AbstractAction("Start Real Time Capture") {
      public void actionPerformed(ActionEvent ev){// throws Exception {
        startRTCapture();
      }
    };
  }

  /**
   * Stop Real time capture action
   * @return Action
   */
  private Action actionStopRTCapture() {
    return new AbstractAction("Stop Real Time Capture") {
      public void actionPerformed(ActionEvent ev){// throws Exception {
        stopRTCapture();
      }
    };
  }

  /**
   * Color detection action
   * @return Action
   */
  private Action actionProcessImage() {
    return new AbstractAction("Color Detect Image") {
      public void actionPerformed(ActionEvent ev){// throws Exception {
        //colorDetection();
      }
    };
  }
  /**
   * Sobel edge detection action
   * @return Action
   */
  private Action actionFindEdges() {
    return new AbstractAction("Sobel Edge Detection") {
      public void actionPerformed(ActionEvent ev){// throws Exception {
        findEdges();
      }
    };
  }
  /**
   * Edge detection action
   * @return Action
   */
  private Action actionToggleFindSobelEdges() {
    return new AbstractAction("Toggle Edge Detection") {
      public void actionPerformed(ActionEvent ev){// throws Exception {
        displayThread.setEdgeType(edgeSelector.getSelectedIndex());
        displayThread.toggleFindEdges();
      }
    };
  }
  /**
   * Full edge detection action
   * @return Action
   */
  private Action actionToggleFindEdges() {
    return new AbstractAction("Toggle Full Edge Detection") {
      public void actionPerformed(ActionEvent ev){// throws Exception {
        displayThread.toggleFindFullEdges();
      }
    };
  }

  /**
   * Gray scale action
   * @return Action
   */
  private Action actionToggleGrayScale() {
    return new AbstractAction("Toggle Grey Scale") {
      public void actionPerformed(ActionEvent ev){// throws Exception {
        displayThread.toggleGrayScale();
      }
    };
  }
  /**
   * Black and white action
   * @return Action
   */
  private Action actionToggleBlackWhite() {
    return new AbstractAction("Toggle Black & White") {
      public void actionPerformed(ActionEvent ev){// throws Exception {
        displayThread.toggleBlackWhite();
      }
    };
  }
  /**
   * Color detection action
   * @return Action
   */
  private Action actionToggleColorDetection() {
    return new AbstractAction("Toggle Color Detection") {
      public void actionPerformed(ActionEvent ev){// throws Exception {
        displayThread.toggleColorDetection();
      }
    };
  }
  /**
   * Black and white action
   * @return Action
   */
  private Action actionConvertBW() {
    return new AbstractAction("Black & White") {
      public void actionPerformed(ActionEvent ev) {
        convertToBWImage();
      }
    };
  }

  /**
   * Gaussian Blur action
   * @return Action
   */
  private Action actionBlur() {
    return new AbstractAction("Gaussian Blur") {
      public void actionPerformed(ActionEvent ev) {
        blurImage();
      }
    };
  }

  /**
   * Find motion action
   * @return Action
   */
  private Action actionToggleFindMotion() {
    return new AbstractAction("Toggle Find Motion") {
      public void actionPerformed(ActionEvent ev) {
        displayThread.toggleFindMotion();
      }
    };
  }

  /**
   * Gaussian blur action
   * @return Action
   */
  private Action actionToggleGaussianBlur() {
    return new AbstractAction("Toggle Gaussian Blur") {
      public void actionPerformed(ActionEvent ev) {
        displayThread.toggleGaussianBlur();
      }
    };
  }

  /**
   * Start Real Time capture
   * @throws Exception
   */
  private void startRTCapture(){// throws Exception{
    displayThread = new DisplayImage(ip, frameGrab, new PMotionCalculator(detectPanel, decodePanel, new Translator(nns)));
    displayThread.start();
    FPSTimer = new java.util.Timer();
    FPSTimer.schedule(new UpdateFPS(),0,1000);
  }

  /**
   * Stop Real Time Capture
   */
  private void stopRTCapture() {
    FPSTimer.cancel();
    displayThread.stopCapture();
  }

  
  /**
   * Capture still image
   */
  private void captureImage() {
    try {
      ip.setImage(frameGrab.getBufferedImage());
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  /**
   * Convert current image to BW image
   */
  private void convertToBWImage() {
    ip.setImage(ColorManipulation.Binarization(ip.getImage()));
  }

  /**
   * Find edges on the current image
   */
  private void findEdges() {
    //ip.setImage(EdgeDetection.sobalDetection(ip.getImage(),EdgeDetection.SOBEL_VERT));
  }

  /**
   * Perform color detection on current image
   * @throws Exception
   */
  private void colorDetection() throws Exception {
    ip.setImage(ColorDetection.colorProcessImage(ip.getImage()));
  }

  /**
   * Perform gaussian blur on current image
   */
  private void blurImage() {
    GaussianBlurFilter gb=new GaussianBlurFilter();
    ip.setImage(gb.gaussianBlur(ip.getImage()));
  }

  /**
   * Update the fps counter
   */
  class UpdateFPS extends TimerTask {
    public void run() {
      fpsLabel.setText("FPS : " + displayThread.getFrameCount());
      displayThread.resetFrameCount();
    }
  }
}
