/**
 *
 * <p>Title: ColorDetection</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */


package devs.visionpackage.org.cmotch.visionlibrary;

import java.awt.image.*;
import devs.visionpackage.org.cmotch.robovision.*;
import java.awt.*;

/**
 * Color detection class
 */
public class ColorDetection {
  private final static int X_OFFSET = 0;
   private final static int X_ADD = 10;
   private final static int Y_OFFSET = 0;
   private final static int Y_ADD = 20;

   /**
    * Perform color detection on the input image returning a new image with the colored object highlited
    * @param img BufferedImage input image from camera
    * @throws Exception
    * @return BufferedImage return image with objects highlited in their respective color
    */
  public static BufferedImage colorProcessImage(BufferedImage img) throws Exception {
    VisionImage vision = new VisionImage(img);
    Graphics g = img.getGraphics();

    boolean[] coloursSeen = vision.getColoursSeen();

    /* Determine what color is seen and draw a box around the object */

    if (coloursSeen[VisionImage.RED]) {
      g.setColor(Color.RED);
      drawBoundingBox(vision, g, VisionImage.RED, 1);
    }

    if (coloursSeen[VisionImage.BLUE]) {
      g.setColor(Color.BLUE);
      drawBoundingBox(vision, g, VisionImage.BLUE, 1);
    }

    if (coloursSeen[VisionImage.GREEN]) {
      g.setColor(Color.GREEN);
      drawBoundingBox(vision, g, VisionImage.GREEN, 1);
    }
    return img;
  }

  /**
   * Draw a box around the object that has been seen
   * @param vision VisionImage
   * @param g Graphics
   * @param colour byte
   * @param scalingFactor int
   */
  private static void drawBoundingBox(VisionImage vision, Graphics g, byte colour, int scalingFactor) {
    VisionObject ball = new VisionObject(vision, colour);
    /*  Figure out the size and position of the bounding box  */
    int left = ball.getLeft() * scalingFactor;
    int right = ball.getRight() * scalingFactor;
    int top = ball.getTop() * scalingFactor;
    int bottom = ball.getBottom() * scalingFactor;
    int width = right - left;
    int height = bottom - top;


    /*  First the bounding box, two pixels wide  */
    g.drawRect(left + X_OFFSET, top + Y_OFFSET, width, height);
    g.drawRect(left + X_OFFSET - 1, top + Y_OFFSET - 1, width + 2, height + 2);

    /*  Then two lines joining the diaginally opposite corners to show
     *  the centre
     */
    g.drawLine(left + X_OFFSET, top + Y_OFFSET,
               right + X_OFFSET, bottom + Y_OFFSET);
    g.drawLine(right + X_OFFSET, top + Y_OFFSET,
               left + X_OFFSET, bottom + Y_OFFSET);
  }

}
