/**
 *
 * <p>Title: ImageManipulation</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author Chris Motch
 * @version 1.0
 */
package devs.visionpackage.org.cmotch.visionlibrary;

import java.awt.image.*;
/**
 * Class used for direct pixel by pixel manipulation on a buffered image
 */
public class ImageManipulation {
  private BufferedImage img;
  /**
   * Constructor
   * @param inputImg BufferedImage
   */
  public ImageManipulation(BufferedImage inputImg) {
    img = inputImg;
  }
  /**
   * Return image
   * @return BufferedImage
   */
  public BufferedImage getImage() {
    return img;
  }
  /**
   * Get Image height
   * @return int
   */
  public int imgHeight() {
    return img.getHeight();
  }
  /**
   * Get Image width
   * @return int
   */
  public int imgWidth() {
    return img.getWidth();
  }

  /**
   * Get Red Pixel
   * @param x int
   * @param y int
   * @return int
   */
  public int getredPixel(int x, int y) {
    return (img.getRGB(x, y) & 0x00ff0000) >> 16;
  }
  /**
   * Get green pixel
   * @param x int
   * @param y int
   * @return int
   */
  public int getgreenPixel(int x, int y) {
    return (img.getRGB(x, y) & 0x0000ff00) >> 8;
  }
  /**
   * Get blue pixel
   * @param x int
   * @param y int
   * @return int
   */
  public int getbluePixel(int x, int y) {
    return (img.getRGB(x, y) & 0x000000ff);
  }
  /**
   * Set red pixel
   * @param x int
   * @param y int
   * @param value int
   */
  public void setRedPixel(int x, int y, int value) {
    img.setRGB(x, y, (img.getRGB(x, y) & 0xff00ffff) | (value << 16));
  }
  /**
   * Set green pixel
   * @param x int
   * @param y int
   * @param value int
   */
  public void setGreenPixel(int x, int y, int value) {
    img.setRGB(x, y, (img.getRGB(x, y) & 0xffff00ff) | (value << 8));
  }
  /**
   * Set blue pixel
   * @param x int
   * @param y int
   * @param value int
   */
  public void setBluePixel(int x, int y, int value) {
    img.setRGB(x, y, (img.getRGB(x, y) & 0xffffff00) | value);
  }

  /**
   * Set rgb pixel
   * @param x int
   * @param y int
   * @param r int
   * @param g int
   * @param b int
   */
  public void setRGBPixels(int x, int y, int r, int g, int b) {
    img.setRGB(x, y, 0xff000000 | (r << 16) | (g << 8) | b);
  }
}
