/*
 * FaceVis.java
 *
 * Created on March 13, 2005, 9:52 AM
 */

package devs.visionpackage.roebi;

import javax.swing.*;
import java.awt.*;

/**
 *
 * @author  Reto
 */

public class FaceVis extends JComponent {
    private int face_w, face_h, eye_w, eye_h, eyeBrow_h;
    private int mouthUp, mouthPosCorr_y, mouthUp_h, mouthDown_h;
    private int pupile_d, iris_d, gazeDirection;
    private int lEyePos_x, lEyePos_y, lEyePupile_x, lEyePupile_y, lEyeBrow_y;
    private int rEyePos_x, rEyePos_y, rEyePupile_x, rEyePupile_y, rEyeBrow_y;
    private int nose_x, nose_y, nose_w, nose_h , nose_sa, nose_a;
    private int mouth_x, mouth_y, mouth_w, mouth_h, mouth_smile;
    private BasicStroke fine = new BasicStroke(1.f);
    private BasicStroke mid = new BasicStroke(2, BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND);
    private BasicStroke wide = new BasicStroke(4, BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND);
    
    /** Creates a new instance of FaceVis */
    public FaceVis(int width, int height) {
        // panel: 130/110
        face_w = width;
        face_h = height;
        
        eye_w = 35;
        eye_h = 15;
        pupile_d = 8;
        iris_d = 15;
        gazeDirection = 0;
        
        lEyePos_x = 28*face_w/100;
        lEyePos_y = 40;
        lEyeBrow_y = 20;
 //       lPupile_x = 0;
 //       lPupile_y = 0;
        
        rEyePos_x = face_w-lEyePos_x;
        rEyePos_y = lEyePos_y;
        rEyeBrow_y = lEyeBrow_y;
 //       rPupile_x = 0;
 //       rPupile_y = 0;
        
        nose_w = 20;
        nose_h = 20;
        nose_a = 180;
        nose_sa = 270-nose_a/2;
        
        mouth_w = 50;
        mouth_h = 30;
        mouth_y = 85;
        mouth_smile = 0;
    }
        
    public void paintComponent(Graphics comp) {
        Graphics2D comp2D = (Graphics2D) comp;

        // draw nose
        comp2D.setStroke(fine);
        comp2D.drawArc((face_w-nose_w)/2, (face_h-nose_h)/2, nose_w, nose_h, nose_sa, nose_a);

        // draw eyes (white)
        comp2D.setColor(Color.WHITE);
        comp2D.setStroke(mid);
        comp2D.fillOval(lEyePos_x-eye_w/2, lEyePos_y-eye_h/2, eye_w, eye_h);
        comp2D.fillOval(rEyePos_x-eye_w/2, rEyePos_y-eye_h/2, eye_w, eye_h);

        // draw mouth
        comp2D.setColor(Color.RED);
        comp2D.setStroke(wide);
        comp2D.drawArc((face_w-mouth_w)/2, mouth_y-mouthPosCorr_y-mouthUp_h/2, mouth_w, mouthUp_h, mouthUp, 180);
        comp2D.drawArc((face_w-mouth_w)/2, mouth_y-mouthPosCorr_y-mouthDown_h/2, mouth_w, mouthDown_h, 180, 180);

        // draw eyebrow
        comp2D.setColor(Color.DARK_GRAY);
        comp2D.drawArc(lEyePos_x-eye_w/2, lEyeBrow_y, eye_w, 20 ,35,110);
        comp2D.drawArc(rEyePos_x-eye_w/2, rEyeBrow_y, eye_w, 20 ,35,110);
        
	// draw iris
        comp2D.setColor(Color.blue);
        comp2D.setStroke(fine);
        comp2D.fillOval(lEyePos_x-iris_d/2+gazeDirection, lEyePos_y-iris_d/2, iris_d, iris_d);
        comp2D.fillOval(rEyePos_x-iris_d/2+gazeDirection, rEyePos_y-iris_d/2, iris_d, iris_d);
        
	// draw pupile
        comp2D.setColor(Color.BLACK);
        comp2D.fillOval(lEyePos_x-pupile_d/2+gazeDirection, lEyePos_y-pupile_d/2, pupile_d, pupile_d);
        comp2D.fillOval(rEyePos_x-pupile_d/2+gazeDirection, rEyePos_y-pupile_d/2, pupile_d, pupile_d);

        // redraw eye frame
        comp2D.setColor(Color.DARK_GRAY);
        comp2D.setStroke(mid);
        comp2D.drawOval(lEyePos_x-eye_w/2, lEyePos_y-eye_h/2, eye_w, eye_h);
        comp2D.drawOval(rEyePos_x-eye_w/2, rEyePos_y-eye_h/2, eye_w, eye_h);  
    }
    
    public void setGazeDirection(int gazedirection){
        gazeDirection = (eye_w-iris_d)*(gazedirection-50)/110;
    }
    
    public void setEyeBrow(int eyebrow_y){
        lEyeBrow_y = (20+eyebrow_y)*(lEyePos_y-eye_h/2)/140;
        rEyeBrow_y = lEyeBrow_y;
    }
    
    public void setSmile(int smile){
        if (smile > 0) {
            mouthUp = 0;
            mouthUp_h = mouth_h/2*smile/50;
            mouthDown_h = mouth_h/2*smile/50;
            mouthPosCorr_y = -(mouthUp_h-mouthDown_h)/2;
        } else {
            mouthUp = 180;
            mouthUp_h = mouth_h/2*-smile/50;
            mouthDown_h = mouth_h*-smile/50;
            mouthPosCorr_y = (mouthUp_h+mouthDown_h)/4;
        }
    }
    
    public void setExpression(int eyebrow_y, int gazedirection, int smile, int mouthwidth, int mouthheight) {
        this.setEyeBrow(eyebrow_y);
        this.setGazeDirection(gazedirection);
        this.setSmile(smile);
        mouth_w = 50*mouthwidth/100;
    }
    
    //public void setComponents
}
