/*
 * ImPanel.java
 *
 * Created on March 11, 2005, 10:10 PM
 */

package devs.visionpackage.roebi;

import javax.swing.*;
import java.awt.*;
import java.awt.image.*;

/**
 *
 * @author  Reto
 */
public class ImPanel extends JComponent{
    protected BufferedImage image; // = new BufferedImage(1, 1, BufferedImage.TYPE_INT_RGB);
    private int width, height;
    private int sX, sY , sWidth, sHeight;
    private boolean subimage;
    
    /** Creates a new instance of ImPanel */
    public ImPanel(int displayWidth, int displayHeight) {
        width = displayWidth;
        height = displayHeight;
        sX = 0;
        sY = 0;
        subimage = false;
        image = new BufferedImage(1, 1, BufferedImage.TYPE_INT_RGB);
    }
/*
    public ImPanel(BufferedImage img, int displayWidth, int displayHeight) {
        width = displayWidth;
        height = displayHeight;
        sX = 0;
        sY = 0;
        subimage = false;
        image = img;
    }
*/
    public ImPanel(int displayWidth, int displayHeight, int subImageWidth, int subImageHeight) {
        width = displayWidth;
        height = displayHeight;
        sX = 0;
        sY = 0;
        sWidth = subImageWidth;
        sHeight = subImageHeight;
        subimage = true;
        image = new BufferedImage(1, 1, BufferedImage.TYPE_INT_RGB);
    }

  /*  public ImPanel(BufferedImage img, int displayWidth, int displayHeight, int subImageWidth, int subImageHeight) {
        width = displayWidth;
        height = displayHeight;
        sX = 0;
        sY = 0;
        sWidth = subImageWidth;
        sHeight = subImageHeight;
        subimage = true;
        image = img;
    }
*/
    /**
     * Get a buffered image from the image panel
     * @return BufferedImage
     */
    public BufferedImage getBufferedImage() {
        return image;
    }
    
    /**
     * Set the image to be displayed in the image panel
     * @param image BufferedImage
     */
    public void setBufferedImage(BufferedImage image) {
        this.image = image;
        repaint();
    }
    
    public void setPosition(int x_pos, int y_pos){
        sX = x_pos;
        sY = y_pos;
    }
    
    public void setPosition(int x_pos, int y_pos, int subImageWidth, int subImageHeight){
        sX = x_pos;
        sY = y_pos;
        sWidth = subImageWidth;
        sHeight = subImageHeight;
      }
    
    /**
     *
     * @param gc Graphics
     */
    public void paint(Graphics g) {
        if (!subimage) {
            g.drawImage(image, 0,0,width,height,this);
        } else {
            g.drawImage(image, 0,0,width,height,sX,sY,sX+sWidth,sY+sHeight,this);
        }
    }
    
    /**
     *
     * @return Dimension
     */
    public Dimension getPreferredSize() {
        return new Dimension(image.getWidth(), image.getHeight());
    }
    
    /**
     * Extension by Reto Toengi for getting a part of the image
     */
    public BufferedImage getSubimage(int x, int y, int width, int height) {
        return image.getSubimage(x, y, width, height); 
    }
}
