/*
 * ImProcessor.java
 *
 * Created on March 12, 2005, 10:16 AM
 */

package devs.visionpackage.roebi;

import java.awt.image.BufferedImage;
import devs.visionpackage.roebi.facedetect.*;
/**
 *
 * @author  Reto
 */
public class ImProcessor implements Runnable {
    private Thread process;
    private int sleep;
    private ImPanel in;
    private ImPanel out;
    private ImUpdate iu;
    private BufferedImage temp;
    private CFacedetectApp faceDetectOp;
    private int NoOfObjects;
    private ManProcessor manProc;
    private int faceWidth, faceHeigth;
    private int lefteye_width, lefteye_heigth, lefteye_posx, lefteye_posy;
    private int righteye_width, righteye_heigth, righteye_posx, righteye_posy;
    private int nose_width, nose_heigth, nose_posx, nose_posy;
    private int scale, mouth_width, mouth_heigth, mouth_posx, mouth_posy;
    private int tWidth, tHeight;
    
    /** Creates a new instance of ImProcessor */
    public ImProcessor(ImPanel inputImage, ImPanel outputImage, ImUpdate imageUpdate) {
        in = inputImage;
        out = outputImage;
        iu = imageUpdate;
        sleep = 100;
        faceDetectOp = new CFacedetectApp();
        faceDetectOp.RCobj_InitFaceDetect(in.getWidth(), in.getHeight());
    }
    
    public ImProcessor(ImPanel inputImage, ImPanel outputImage, ImUpdate imageUpdate, ManProcessor manualprocessor) {
        in = inputImage;
        out = outputImage;
        iu = imageUpdate;
        sleep = 100;
        faceDetectOp = new CFacedetectApp();
        faceDetectOp.RCobj_InitFaceDetect(in.getWidth(), in.getHeight());
        manProc = manualprocessor;
    }

    public void startProcessing() {
        if (process == null); {
            process = new Thread(this);
            process.start();
        }
    }
    
    public void stopProcessing() {
        if (process != null); {
            process = null;
        }
    }
    
    public void singleProcessing() {
    // here would be the single processing code/call;
        this.processing();
    }
    
    public void setSleep(int tSleep) {
        sleep = tSleep;
    }

    public void setManX (int Value) {
        manProc.setX(Value);
    }
    
    public void setManY (int Value) {
        manProc.setY(Value);
    }
    
    public void setManSize (int Value) {
        manProc.setSize(Value);
    }
    
    public void run() {
        try {
            while (process == Thread.currentThread()) {
                this.processing();

                try {
                    Thread.sleep(sleep);
                } catch (InterruptedException e) {}
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    
    private void processing () {
        temp = in.getBufferedImage(); //.getSubimage(0,100,400,300);
                
        if (false) {
            /*
             * Martin:
             *
             * Here commes Code for passing the Buffered Image on the C-side
             * It has to be of Class: Type SWIGTYPE_p_p_SAFEARRAY on the JavaSide
             * It has to be a Byte Array on the C-side
             *
             int [] data;
             data = temp.getData().getPixels(0,0, temp.getHeight(), temp.getWidth(), data);

             * 
             * the following code uses the DLL
             *
             */
            NoOfObjects = 0; //faceDetectOp.detectfaces(image.get_ppSAVEARRAY);
            if (NoOfObjects>0) {
                for (int i=0; i >= NoOfObjects-1; i++){
//              faceDetectOp.RCobj_getObject(i, SWIGTYPE_p_int tx, SWIGTYPE_p_int ty, SWIGTYPE_p_int bx, SWIGTYPE_p_int by);

                // expression visualisation update
//                faceDetectOp.RCobj_getFacialFeatures(i,  SWIGTYPE_p_int leftEyeOuter, SWIGTYPE_p_int leftEyeInner, SWIGTYPE_p_int leftEyePupil_x, SWIGTYPE_p_int leftEyePupil_y, SWIGTYPE_p_int leftEyebrow_y, SWIGTYPE_p_int rightEyeOuter, SWIGTYPE_p_int rightEyeInner, SWIGTYPE_p_int rightEyePupil_x, SWIGTYPE_p_int rightEyePupil_y, SWIGTYPE_p_int rightEyebrow_y, SWIGTYPE_p_int smile, SWIGTYPE_p_int mouthOpen, SWIGTYPE_p_int mouthOpenWidth);
//                gazeDirectioni = (leftEyeOuter+leftEyeInner-2*leftEyePupil_x+rigthEyeOuter+rightEyeInner-2*rigthEyePupil_x)/2;
//                eyeBrow = (leftEyePupil_y-leftEyebrow_y+rigthEyePupil_y-rightEyebrow_y)/2;

                // feature image update
//                faceDetectOp.RCobj_detectfeatures(i, SWIGTYPE_p_int lateral_symetry, SWIGTYPE_p_int lefteye_x, SWIGTYPE_p_int righteye_x, SWIGTYPE_p_int lefteye_y, SWIGTYPE_p_int righteye_y, SWIGTYPE_p_int mouth_y, SWIGTYPE_p_int mouth_width, SWIGTYPE_p_int gazedirection);
/*                faceWidth = bx-tx;  //bottom right corner - top left corner
                faceHeigth = by-ty; //bottom right corner - top left corner
                lefteye_posx = tx + lefteye_x*faceWidth/100;
                lefteye_posy = ty + lefteye_y*faceHeigth/100;
                righteye_posx = tx + righteye_x*faceWidth/100;
                righteye_posy = ty + righteye_y*faceHeigth/100;
                nose_posx = tx + nose_x*faceWidth/100;
                nose_posy = ty + nose_y*faceHeigth/100;
                mouth_posx = tx + mouth_x*faceWidth/100;
                mouth_posy = ty + mouth_y*faceHeigth/100;
 */
                }
            }
        } else {
            scale = 100*(manProc.getBX()-manProc.getTX())/temp.getWidth();
            tWidth = temp.getWidth();
            tHeight = temp.getHeight();
            faceWidth = (manProc.getBX()-manProc.getTX())*tWidth/100;  //bottom right corner - top left corner
            faceHeigth = (manProc.getBY()-manProc.getTY())*tHeight/100; //bottom right corner - top left corner
            lefteye_posx = manProc.getTX()*tWidth/100 + (manProc.getLeftEyeX()*faceWidth/100);
            lefteye_posy = manProc.getTY()*tHeight/100 + (manProc.getLeftEyeY()*faceHeigth/100);
            righteye_posx = manProc.getTX()*tWidth/100 + (manProc.getRightEyeX()*faceWidth/100);
            righteye_posy = manProc.getTY()*tHeight/100 + (manProc.getRightEyeY()*faceHeigth/100);
            nose_posx = manProc.getTX()*tWidth/100 + (faceWidth/2);
            nose_posy = manProc.getTY()*tHeight/100 + (faceHeigth/2);
            mouth_posx = manProc.getTX()*tWidth/100 + (faceWidth/2);
            mouth_posy = manProc.getTY()*tHeight/100 + (manProc.getMouthY()*faceHeigth/100);
        }
        // End of processed code;

        out.setBufferedImage(temp);
        //iu.update();
        iu.update(scale,lefteye_posx, lefteye_posy, righteye_posx, righteye_posy, nose_posx, nose_posy, mouth_posx, mouth_posy);
    }
    
}
