/*
 * OpenCVArray.java
 *
 * Created on March 22, 2005, 11:03 PM
 */

package devs.visionpackage.roebi;

import devs.visionpackage.roebi.facedetect.SWIGTYPE_p_int;
import devs.visionpackage.roebi.facedetect.*;
/**
 *
 * @author  Reto
 */

public class OpenCVArray extends facedetect{
    private SWIGTYPE_p_int CPtr;
    private int length;
    
    /** Creates a new instance of OpenCVArray */
    public OpenCVArray(int elements) {
        super();
        CPtr = this.new_intArray(elements);
        length = elements;
    }
    
    public SWIGTYPE_p_int getCPtr() {
        return CPtr;
    }
    
    public int getLength() {
        return length;
    }
    
    public void setArray (int data[]) {
        if (data.length >= length) {
            for (int i=0; i<length; i++) {
                this.intArray_setitem(CPtr, i, data[i]);
            }
        } else {
            for (int i=0; i<data.length; i++) {
                this.intArray_setitem(CPtr, i, data[i]);
            }
        }
    }
    
    public int[] getArray () {
        int[] array = new int[length];
        for (int i=0; i<length; i++) {
            array[i] = this.intArray_getitem(CPtr,i);
        }
        return array;
    }
    
    public void setitem (int index, int value) {
        this.intArray_setitem(CPtr, index,  value);
    }
    
    public int getitem (int index, int value) {
        return this.intArray_getitem(CPtr, index);
    }
}
