#include <string.h>
#include <stdio.h>
#include <math.h>
#include "cv.h"
#include "cvaux.h"

/////////////////////////////////////////////////////////////////////////////
// CFacedetectApp
// See facedetect.cpp for the implementation of this class
//

class CFacedetectApp
{
private:
  void updateTracking();
  void closestMatch(int &x,int &y,int size_x,int size_y,int searchArea);
  void detect_keypoints(int index);
public:

  void RCobj_DetectFaces( IplImage* img );
  int RCobj_InitFaceDetect( int img_width, int img_height );
  int RCobj_detectfaces(char **bmp);
  void RCobj_getObject(int index, int &tx, int &ty, int &bx, int &by);
  void RCobj_setBorder(int borderX, int borderTop, int borderBottom);
  void RCobj_detectfeatures(int index, int &lateral_symetry, int &lefteye_x, int &righteye_x, int &lefteye_y, int &righteye_y, int &mouth_y, int &mouth_width, int &gazedirection);
  void RCobj_trackface(int index);
  void RCobj_detectGazeDirection(int index, int lateral_symetry, int lefteye_x, int righteye_x, int lefteye_y, int righteye_y, int &gazedirection);
  void RCobj_learnFaceOrientation(int orientationID);
  void RCobj_getFacialFeatures(int index, int &leftEyeOuter, int &leftEyeInner, int &leftEyePupil_x, int &leftEyePupil_y, int &leftEyebrow_y, int &rightEyeOuter, int &rightEyeInner, int &rightEyePupil_x, int &rightEyePupil_y, int &rightEyebrow_y, int &smile, int &mouthOpen, int &mouthOpenWidth);

  CFacedetectApp();
  ~CFacedetectApp();
};
