/* File : facedetect.i */

/* specifies the module name after creation, if not specified from the SWIG call */
%module facedetect

/* header files included, don't get parsed by the SWIG. They make its way direct to the wrapper file. */
%{
#include "facedetect.h"
%}

/* Let's just grab the original header file here */
/* additional integer array creation */
%include "carrays.i"
%array_functions(int, intArray);
%apply char[][] { char [][] };
%array_functions(char, byteArray);

/* So far no solution for the byte array pointer!!!
//%include "typemaps.i"
//%apply char[][] *INOUT { char **bmp };
//int CFacedetectApp::RCobj_detectfaces(char **bmp);
*/

/*
%include "typemaps.i"
%include "arrays_java.i"
%inline %{
int CFacedetectApp::RCobj_detectfaces(char **bmp);
%}
*/

%ignore CFacedetectApp::RCobj_detectfaces;
int CFacedetectApp::RCobj_detectfaces(char **bmp);
  inline void test_CFacedetectApp::RCobj_detectfaces(signed char t[][]) {
   CFacedetectApp::RCobj_detectfaces((char**) t);
}


/* special type maps for references passed to the methods. This needs to be done, before the complete class gets wrapped, otherwise the SWIG can not apply the wrapped types */
%include "typemaps.i"

%apply int *OUTPUT {int &leftEyeOuter};
%apply int *OUTPUT {int &leftEyeInner};
%apply int *OUTPUT {int &leftEyePupil_x};
%apply int *OUTPUT {int &leftEyePupil_y};
%apply int *OUTPUT {int &leftEyebrow_y};
%apply int *OUTPUT {int &rightEyeOuter};
%apply int *OUTPUT {int &rightEyeInner};
%apply int *OUTPUT {int &rightEyePupil_x};
%apply int *OUTPUT {int &rightEyePupil_y};
%apply int *OUTPUT {int &rightEyebrow_y};
%apply int *OUTPUT {int &smile};
%apply int *OUTPUT {int &mouthOpen};
%apply int *OUTPUT {int &mouthWidth};
void CFacedetectApp::RCobj_getFacialFeatures(int index, int &leftEyeOuter, int &leftEyeInner, int &leftEyePupil_x, int &leftEyePupil_y, int &leftEyebrow_y, int &rightEyeOuter, int &rightEyeInner, int &rightEyePupil_x, int &rightEyePupil_y, int &rightEyebrow_y, int &smile, int &mouthOpen, int &mouthWidth);

%apply int *OUTPUT {int &tx};
%apply int *OUTPUT {int &ty};
%apply int *OUTPUT {int &bx};
%apply int *OUTPUT {int &by};
void CFacedetectApp::RCobj_getObject(int index, int &tx, int &ty, int &bx, int &by);

%apply int *OUTPUT {int &lateral_symetry};
%apply int *OUTPUT {int &lefteye_x};
%apply int *OUTPUT {int &righteye_x};
%apply int *OUTPUT {int &lefteye_y};
%apply int *OUTPUT {int &righteye_y};
%apply int *OUTPUT {int &mouth_y};
%apply int *OUTPUT {int &mouth_width};
%apply int *OUTPUT {int &gazedirection};
void CFacedetectApp::RCobj_detectfeatures(int index, int &lateral_symetry, int &lefteye_x, int &righteye_x, int &lefteye_y, int &righteye_y, int &mouth_y, int &mouth_width, int &gazedirection);

%apply int *OUTPUT {int &gazedirection};
void CFacedetectApp::RCobj_detectGazeDirection(int index, int lateral_symetry, int lefteye_x, int righteye_x, int lefteye_y, int righteye_y, int &gazedirection);

/* wrapping of entire header file. With the already wrapped critical methods the SWIG can wrap now the rest easy stuff */
%include "facedetect.h"
