package mainframe;
import javax.swing.tree.*;


/** This class forces "male" nodes to have leaf icons and
forbids male childbaring ability */
public class DeviceNode extends DefaultMutableTreeNode  {

  public DeviceNode(DeviceInfo info) {
    super(info);
  }

  /** Override a few methods... */
  public boolean isLeaf() {
    //Note: Male == true;
    return ((DeviceInfo) getUserObject()).isDevice();
  }

  public boolean getAllowsChildren() {
    //Note: Features cannot have children
    return !((DeviceInfo) getUserObject()).isFeature();
  }

  public void add(DefaultMutableTreeNode child) {
    super.add(child);
   System.out.println(child + " added to " + this);

    DeviceInfo childPI = (DeviceInfo) ((DeviceNode) child).getUserObject();

    DeviceInfo oldParent = childPI.getParent();
    if (parent != null) oldParent.remove(childPI);

    DeviceInfo newParent = (DeviceInfo) getUserObject();

    newParent.add(childPI);
  }

  public void remove(DefaultMutableTreeNode child) {
    super.remove(child);
    System.out.println(child + " removed from " + this);

    DeviceInfo childPI = (DeviceInfo) ((DeviceNode) child).getUserObject();

    DeviceInfo ParentPI = (DeviceInfo) getUserObject();
    if (parent != null) ParentPI.remove(childPI);
  }
}
