package mainframe;
/*
 * Created on October 2003 
 */
import java.io.File;


class Message
{
	/**
	 * Constructor allowing to track the message
	 * @param origin - origin class of the message
	 * @param message - the body of the message
	 */
	Message(Object origin, String message){
		this.origin = origin;
		this.message = message;
	}
	
	/**
	 * Default constuctor
	 */
	Message()
	{
		
	}
	private Object origin;
	private String message;
	
	/**
	 * @return Returns the message.
	 */
	public String getMessage() {
		return message;
	}

	/**
	 * @return Returns the origin.
	 */
	public Object getOrigin() {
		return origin;
	}
	
	
}

/*
 * This is a sub class of Message as can be seen
 *  It is used specifically to transport pointers to files
 *  and to Strings that do not require a back tracking
 *  Mainly used to send data to the parser or the CNS 
 */
class FileMessage extends Message
{
	/**
	 * Constructor using a File
	 * @param f - File f
	 */
	FileMessage(File file){
		super();
		this.file = file;
	}
	
	/**
	 * Constructor using a String
	 * @param s - String
	 */
	FileMessage(String line){
		super();
		this.line = line;
	}
	
	/**
	 * @return Returns the f.
	 */
	public File getFile() {
		return file;
	}

	/**
	 * @return Returns the s.
	 */
	public String getLine() {
		return line;
	}
	
	private File file;
	private String line;
	
}