package monitors;
/*
 * A system dump class. all messages are redirected into this message dump
 * Usefull for debugging and to check additional information during problem encountering 
 * This will theoretically constitute the future openings for a complete language support 
 * so as to provide tools to verify , check and program CRL and complete CRL based robots 
*/
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Font;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.JTextArea;
import javax.swing.JViewport;
import javax.swing.UIManager;

import mainframe.MIFrame;
import mainframe.MainFrame;
/**
 * @author Martin Lukac 2003/2004
 */

public class CoLsole extends MIFrame implements ActionListener{

	private JTabbedPane pane;
	private JViewport port;
	
	/**
	 * @param width
	 * @param height
	 */
	CoLsole(int width, int height) {
		super(width, height, "CoLsole", true, false);
        System.out.println("Starting colsole");

		try {
			UIManager.setLookAndFeel(
				UIManager.getCrossPlatformLookAndFeelClassName());
		} catch (Exception exc) {
			System.err.println("Error loading L&F: " + exc);
		}
	
        // Specify on which edge the tabs should appear
        int location = JTabbedPane.TOP; // or BOTTOM, LEFT, RIGHT
        
        // Create the tabbed pane
        pane = new JTabbedPane();
        pane.setFont(MainFrame.CrideBFont);

		//It is a tabbed console with tabs that have all different specifications
		JPanel panel = new JPanel();
		JScrollPane scroller = new JScrollPane();
		port = scroller.getViewport();
		port.setAutoscrolls(true);
		messMain = new JTextArea();
        messMain.setFont(MainFrame.CrideNFont);
		messMain.setEditable(false);
		messMain.setCaretColor(Color.RED);
		messMain.setLineWrap(true);
		messMain.setText("Main messages");
		port.add(messMain);
		panel = new JPanel();
		panel.setFont(MainFrame.CrideBFont);
		panel.setLayout(new BorderLayout());
		panel.add("Center", scroller);
		String label = "Main";
		pane.addTab(label, panel);
		
		panel = new JPanel();
        panel.setFont(MainFrame.CrideBFont);
		scroller = new JScrollPane();
		port = scroller.getViewport();
		messError = new JTextArea();
        messError.setFont(MainFrame.CrideNFont);
		messError.setEditable(false);
		messError.setCaretColor(Color.GREEN);
		messError.setLineWrap(true);
		messError.setText("Error messasges");
		port.add(messError);
		panel.setLayout(new BorderLayout());
		panel.add("Center", scroller);
		label = "Errors";
		pane.addTab(label, panel);
//		getContentPane().add(pane);

		panel = new JPanel();
		scroller = new JScrollPane();
		port = scroller.getViewport();
		messDebug = new JTextArea();
        messDebug.setFont(MainFrame.CrideNFont);
		messDebug.setLineWrap(true);
		messDebug.setText("Debug messasges");
		messDebug.setEditable(false);
		port.add(messDebug);
		panel.setLayout(new BorderLayout());
		panel.add("Center", scroller);
		label = "Debug";
		pane.addTab(label, panel);
//		getContentPane().add(pane);

		panel = new JPanel();
		scroller = new JScrollPane();
		port = scroller.getViewport();
		messBio = new JTextArea();
        messBio.setFont(MainFrame.CrideNFont);
		messBio.setLineWrap(true);
		messBio.setText("Bio messasges");
		messBio.setEditable(false);
		port.add(messBio);
		panel.setLayout(new BorderLayout());
		panel.add("Center", scroller);
		label = "Bio messages";
		pane.addTab(label, panel);
//		getContentPane().add(pane);

		panel = new JPanel();
		panel.setLayout(new GridLayout(1,2));
		debug = new JButton("debug");
		debug.addActionListener(this);
		debug.setActionCommand("debug");
		panel.add(debug); 
		logs = new JButton("logs");
		logs.addActionListener(this);
		logs.setActionCommand("logs");
		panel.add(logs); 
		label = "Tools";
		pane.addTab(label, panel);
		getContentPane().add(pane);

	}

	public void processMessage(Object mfE)
	{
		messMain.append(mfE.toString()+'\n');
		repaint();
	}

	public void processError(Object mfE)
	{
		messError.append(mfE.toString()+'\n');
		repaint();
	}

	public void processDebug(Object mfE)
	{
	    String message = mfE.toString();
	    message = message.substring(message.lastIndexOf(':')+1);
	    message = message.trim();
	    if (message.startsWith("clean"))
	        messDebug.setText("");
	    else
	        messDebug.append(mfE.toString()+'\n');
		repaint();
	}
	public void processBio(Object mfE)
	{
		messBio.append(mfE.toString()+'\n');
		repaint();
	}

	//The two text fields of the console
	private JTextArea messMain;
	private JTextArea messError;
	private JTextArea messDebug;
	private JTextArea messBio;
	private JButton debug, logs;

	/* (non-Javadoc)
	 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
	 */
	public void actionPerformed(ActionEvent e) {

		if (e.getActionCommand().equalsIgnoreCase(debug.getActionCommand()))
			CommCenter.toggleDebug();
		else if (e.getActionCommand().equalsIgnoreCase(logs.getActionCommand()))
			CommCenter.toggleLogging();
	}
}


