package monitors;
/*
 * Created on Jan 2, 2004
 * 
 *  
 */
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.PrintStream;
import java.util.List;

import javax.swing.JDesktopPane;
import javax.swing.JLayeredPane;
import javax.swing.JPanel;
/**
 * @author Martin Lukac
 * @version Jan 2, 2004
 *  
 */
public class CommCenter extends Thread{

	/**
	 *  
	 */
	public CommCenter(JDesktopPane desktop) {
		super();
		CommCenter.desktop = desktop;
		//createConsole();
		createLogs();
		enabled = true;
		initTime = System.currentTimeMillis();
		//System.setErr(err);
		//System.setOut(out);
	}


    public CommCenter() {
    super();
    createLogs();
    enabled = true;
    initTime = System.currentTimeMillis();
    //System.setErr(err);
    //System.setOut(out);
    }

	/**
     * @return Returns the desktop.
     */
    public static synchronized JDesktopPane getDesktop() {
        return desktop;
    }


    /**
     * @param desktop The desktop to set.
     */
    public static synchronized void setDesktop(JDesktopPane desktop) {
        CommCenter.desktop = desktop;
    }


    public static void createConsole() {
		int width = desktop.getWidth();
		int height = desktop.getHeight();
		width = (int) (width / 2);
		height = (int) (height / 5);
		//System.out.println("creating console" + width + "  " + height);
		colsole = new CoLsole(width, height);
        //colsole.setConsole(panel);
		colsole.setClosable(false);
		colsole.reshape(/*(int) (desktop.getWidth() - width)*/0, desktop.getHeight()
				- height, width, height);
        colsole.setVisible(true);
        desktop.add(CommCenter.colsole, JLayeredPane.DEFAULT_LAYER);
	}
	
	private static void createLogs(){
	    File location = new File(LOG_LOCATION);
	    logFiles = new File [writernames.length];
	    for (int a = 0; a < writernames.length; a++){
	    if (location.exists()){
	        logFiles[a] = new File(location.getPath()+"/"+writernames[a]+".log");
	        if (logFiles[a].exists()){
	            logFiles[a].renameTo(new File(location.getPath()+"/"+"OLD"+writernames[a]+".log"));   
	        }
	    }
	    logFiles[a] = new File(location.getPath()+"/"+writernames[a]+".log");
	    System.out.println("Logfile "+logFiles[a].getPath()+" is created");
	    }
	    
	}

	synchronized public static void openLogs(){
	    try {
            CommCenter.setEnabled(true);
	        fwrs = new FileWriter[writernames.length];
	        for (int a = 0; a < writernames.length; a++){
	            fwrs[a] = new FileWriter(logFiles[a]);
	            System.out.println("Log open: "+logFiles[a]);
	            fwrs[a].write("Log open on: "+System.getProperty("date")+'\n');
		    }
	    } catch(IOException io){
	    }
	}

	synchronized public static void closeLogs(){
	    try {
            CommCenter.setEnabled(false);
	        for (int a = 0; a < writernames.length; a++){
	            fwrs[a].flush();
	            fwrs[a].close();
		    }
	    } catch(IOException io){
	        
	    }

	}

	/**
	 * @return Returns the enabled.
	 */
	public static synchronized boolean isEnabled() {
		return enabled;
	}
	/**
	 * @param enabled The enabled to set.
	 */
	public static synchronized void setEnabled(boolean enabled) {
		CommCenter.enabled = enabled;
	}
	/**
	 * @param o -
	 *                  generates an event to the GUI but can process the object
	 */
	public static synchronized void showComm(Object o) {
		if (colsole != null){
			if (enabled) colsole.processMessage(getRunTime()+" :: "+o);
		}else System.out.println(o);
		
		if (logging)
		    try {
			    fwrs[0].write("MESSAGE: "+getRunTime()+" :: "+o+'\n');	        
		    } catch (IOException io){
		        
		    }
	}
	/**
	 * 
	 * @param m - formated type of popups
	 */
	public static synchronized void showError(Object m){
		if (colsole != null){
			if (enabled) colsole.processError(getRunTime()+" :: "+m);
		}else System.out.println(m);

		if (logging)
		    try {
		        fwrs[2].write("ERROR: "+getRunTime()+" :: "+m+'\n');	        
		    } catch (IOException io){
		        
		    }
	}
	/**
	 * 
	 * @param m - formated type of popups
	 */
	public static synchronized void showDebug(Object m){
		if (enabled && debug) colsole.processDebug(getRunTime()+" :: "+m);

		if (logging)
		    try {
		        fwrs[1].write("DEBUG: "+getRunTime()+" :: "+m+'\n');	        
		    } catch (IOException io){
		        
		    }
	}
	/**
	 * 
	 * @param m - formated type of popups
	 */
	public static synchronized void showBioData(Object m){
		if (enabled) colsole.processBio(getRunTime()+" :: "+m);
		
		if (logging)
		    try {
		        fwrs[3].write("BIODATA : "+getRunTime()+" :: "+m+'\n');	        
		    } catch (IOException io){
		        
		    }

	}

	synchronized public static void toggleLogging(){

		logging = !logging;
		if(logging)
		    openLogs();
		else
		    closeLogs();
        if (logging)
            showComm("Loging is: Enabled");
        else showComm("Loging is: Diabled");
	}
	/**
	 * 
	 */
	synchronized public static void toggleDebug(){
		debug = !debug;
		if (debug)
		    showDebug("clean");
		showComm("Debug mode is: "+debug);
	}
	
	static private String getRunTime(){
		int currentTime = (int)System.currentTimeMillis();
		currentTime -= initTime;
		currentTime /= 1000; //put it in seconds
		String time = "";
		time = (currentTime/3600)+":";
		int t = currentTime % 3600;
		time = time+(t/60)+":"+(t%60);
		return time;
	}
	//The listeners of the comm center
	private List Listeners;

	private static JDesktopPane desktop;
	
	public static CoLsole colsole;

	private static boolean enabled = false;
	
	private static boolean debug = false;
	
	private static boolean logging = false;
	
	private static String LOG_LOCATION ="logs/robot";
	
	
	private static File [] logFiles;	
	private static FileWriter [] fwrs;
	private static String [] writernames = {"comms", "debug", "error", "biodata"};
	private static InputStream in;
	
	private static PrintStream err, out;
	
	private static long initTime;
	/**
	 * @return Returns the debug.
	 */
	public static boolean isDebug() {
		return debug;
	}
	
	class InputReader implements Runnable{
		
		
		public InputReader(InputStream in){
			super();
			CommCenter.in = in;
			start();
		}
		
		public void run(){
			while(true){
				try{
					int line = in.read();
				} catch (IOException e){
					
				}
			}
			
		}
	}
	
	/**
	 * @param debug The debug to set.
	 */
	public static void setDebug(boolean debug) {
		CommCenter.debug = debug;
	}
}
