package monitors;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.FileDialog;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.Label;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.IOException;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.SwingUtilities;
import javax.swing.border.EtchedBorder;

import mainframe.MIFrame;
import mainframe.MainFrame;
import mns.Messages;
import nns.BioSensor;
import nns.NNS;
import robot.Robot;
import brain.NetClient.RobotClient;
import brain.alice.AliceBasedInterface;
import devs.musicpackage.DanceGenerator;
import devs.musicpackage.SpectrumAnalyzer;

/*
 * Created on Jan 7, 2004
 */
/**
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 * 
 * @author Martin Lukac
 */
public class MNSRobotPanel extends MIFrame implements ActionListener {

    public MNSRobotPanel(Robot robotSystem, JPanel sidePanel) {
        super(800, 450, Messages.getString("MNSRobotPanel.0"), true, false); //$NON-NLS-1$

        this.sidePanel = sidePanel;
        robot = robotSystem;
        files = new Vector(5, 2);

        Container contentPane = getContentPane();
        GridBagLayout mainGrid = new GridBagLayout();
        contentPane.setLayout(mainGrid);
        GridBagConstraints mainC = new GridBagConstraints();

        GridBagLayout panelGrid = new GridBagLayout();
        GridBagConstraints panstraints = new GridBagConstraints();

        JPanel top = new JPanel(new GridLayout(1,1), false);
        top.add(addPartPanel(), "CENTER");
        mainC.weightx = 100;
        mainC.weighty = 100;
        mainC.fill = GridBagConstraints.BOTH;
        add(top, mainC, 0, 0, 6, 5);

        JPanel bottom = new JPanel(new GridLayout(1,1), false);
        bottom.add(addComPanel(), "CENTER");
        mainC.weightx = 100;
        mainC.weighty = 100;
        mainC.fill = GridBagConstraints.BOTH;
        add(bottom, mainC, 0, 5, 6, 5);

        panelGrid = new GridBagLayout();
        panstraints = new GridBagConstraints();
        JPanel right = new JPanel(panelGrid, false);
        panstraints.fill = GridBagConstraints.BOTH;
        panstraints.weightx = 60;
        panstraints.weighty = 100;
        panstraints.fill = GridBagConstraints.BOTH;
        add(addControlPanel(), panstraints, 0, 0, 4, 8, right);
        mainC.weightx = 0;
        mainC.weighty = 100;
        mainC.fill = GridBagConstraints.BOTH;
        add(right, mainC, 10, 0, 4, 12);

        panelGrid = new GridBagLayout();
        panstraints = new GridBagConstraints();
        bottom = new JPanel(new GridLayout(1,1), false);
        bottom.add(addNetPanel(), "CENTER");
        mainC.weightx = 100;
        mainC.weighty = 100;
        mainC.fill = GridBagConstraints.BOTH;
        add(bottom, mainC, 0, 10, 10, 2);

        // panelGrid = new GridBagLayout();
        // panstraints = new GridBagConstraints();
        // bottom = new JPanel(panelGrid, false);
        // panstraints.fill = GridBagConstraints.BOTH;
        // panstraints.weightx = 100;
        // panstraints.weighty = 100;
        // add(sensorPanel(), panstraints, 0, 0, 4, 2, bottom);
        // mainC.weightx = 100;
        // mainC.weighty = 100;
        // mainC.fill = GridBagConstraints.BOTH;
        // add(bottom, mainC, 5, 10, 5, 2);

        robot.addMNSMonitor(this);
        startNetClient();

    }

    private JPanel addComPanel() {

        GridBagLayout controlGrid = new GridBagLayout();
        GridBagConstraints constraints = new GridBagConstraints();
        JPanel comPanel = new JPanel(controlGrid, false);
        comPanel.setFont(MainFrame.CrideBFont);
        comPanel.setBorder(BorderFactory.createTitledBorder(Messages
                .getString("MNSRobotPanel.2")));
        commandArea = new JTextArea();
        commandArea.setFont(MainFrame.CrideNFont);
        commandArea.setColumns(80);
        commandArea.setLineWrap(true);
        commandArea.setEditable(false);
        constraints.fill = GridBagConstraints.BOTH;
        constraints.weightx = 100;
        constraints.weighty = 100;
        add(new JScrollPane(commandArea), constraints, 0, 0, 1, 1, comPanel);

        return comPanel;
    }

    private JPanel addNetPanel() {

        GridBagLayout controlGrid = new GridBagLayout();
        GridBagConstraints constraints = new GridBagConstraints();
        JPanel netPanel = new JPanel(controlGrid, false);
        netPanel.setFont(MainFrame.CrideBFont);
        netPanel.setBorder(BorderFactory.createTitledBorder(Messages
                .getString("MNSRobotPanel.3")));

        GridBagLayout Grid = new GridBagLayout();
        GridBagConstraints cstrs = new GridBagConstraints();
        cstrs.weightx = 100;
        cstrs.weighty = 100;
        cstrs.fill = GridBagConstraints.BOTH;
        JPanel buttonPanel = new JPanel(Grid, false);

        Grid = new GridBagLayout();
        cstrs = new GridBagConstraints();
        cstrs.weightx = 0;
        cstrs.weighty = 0;
        cstrs.fill = GridBagConstraints.BOTH;
        buttonPanel = new JPanel(Grid, false);

        netinitButton = new JButton(Messages.getString("MNSRobotPanel.5")); //$NON-NLS-1$
        netinitButton.setFont(MainFrame.CrideBFont);
        netinitButton.addActionListener(this);
        add(netinitButton, cstrs, 0, 0, 1, 1, buttonPanel);

        connectButton = new JButton(Messages.getString("MNSRobotPanel.6")); //$NON-NLS-1$
        connectButton.addActionListener(this);
        connectButton.setFont(MainFrame.CrideBFont);
        add(connectButton, cstrs, 1, 0, 1, 1, buttonPanel);

        quitButton = new JButton(Messages.getString("MNSRobotPanel.7")); //$NON-NLS-1$
        quitButton.setFont(MainFrame.CrideBFont);
        quitButton.addActionListener(this);
        add(quitButton, cstrs, 0, 1, 1, 1, buttonPanel);

        sendButton = new JButton(Messages.getString("MNSRobotPanel.8")); //$NON-NLS-1$
        sendButton.setFont(MainFrame.CrideBFont);
        sendButton.addActionListener(this);
        add(sendButton, cstrs, 1, 1, 1, 1, buttonPanel);

        whisperButton = new JButton(Messages.getString("MNSRobotPanel.9")); //$NON-NLS-1$
        whisperButton.setFont(MainFrame.CrideBFont);
        whisperButton.addActionListener(this);
        add(whisperButton, cstrs, 0, 2, 1, 1, buttonPanel);

        whoButton = new JButton(Messages.getString("MNSRobotPanel.10")); //$NON-NLS-1$
        whoButton.setFont(MainFrame.CrideBFont);
        whoButton.addActionListener(this);
        add(whoButton, cstrs, 1, 2, 1, 1, buttonPanel);

        fileButton = new JButton(Messages.getString("MNSRobotPanel.11")); //$NON-NLS-1$
        fileButton.setFont(MainFrame.CrideBFont);
        fileButton.addActionListener(this);
        add(fileButton, cstrs, 0, 3, 1, 1, buttonPanel);

        add(fileButton, cstrs, 1, 3, 1, 1, buttonPanel);

        constraints.fill = GridBagConstraints.NONE;
        constraints.weightx = 0;
        constraints.weighty = 100;
        add(buttonPanel, constraints, 0, 0, 2, 4, netPanel);

        Grid = new GridBagLayout();
        cstrs = new GridBagConstraints();
        cstrs.weightx = 100;
        cstrs.weighty = 100;
        cstrs.fill = GridBagConstraints.BOTH;

        buttonPanel = new JPanel(Grid, false);
        netArea = new JTextArea();
        netArea.setFont(MainFrame.CrideNFont);
        netArea.setEditable(false);
        netArea.setLineWrap(true);
        netArea.setColumns(50);
        add(new JScrollPane(netArea), cstrs, 0, 0, 6, 4, buttonPanel);

        constraints.fill = GridBagConstraints.BOTH;
        constraints.weightx = 100;
        constraints.weighty = 100;
        add(buttonPanel, constraints, 2, 0, 6, 4, netPanel);

        Grid = new GridBagLayout();
        cstrs = new GridBagConstraints();
        cstrs.weightx = 100;
        cstrs.weighty = 100;
        cstrs.fill = GridBagConstraints.HORIZONTAL;
        buttonPanel = new JPanel(Grid, false);
        setFont(MainFrame.CrideBFont);
        add(
                new JLabel(Messages.getString("MNSRobotPanel.4")), cstrs, 0, 0, 1, 1, buttonPanel); //$NON-NLS-1$
        netmessage = new JTextField(20);
        netmessage.setFont(MainFrame.CrideNFont);
        add(netmessage, cstrs, 1, 0, 5, 1, buttonPanel);

        constraints = new GridBagConstraints();
        constraints.fill = GridBagConstraints.BOTH;
        constraints.weightx = 100;
        constraints.weighty = 100;
        add(buttonPanel, constraints, 0, 4, 8, 1, netPanel);

        return netPanel;
    }

    private JPanel addPartPanel() {

        GridBagLayout controlGrid = new GridBagLayout();
        GridBagConstraints constraints = new GridBagConstraints();
        JPanel partPanel = new JPanel(controlGrid, false);
        partPanel.setBorder(BorderFactory.createTitledBorder(Messages
                .getString("MNSRobotPanel.1")));

        partArea = new JTextArea();
        partArea.setFont(MainFrame.CrideNFont);
        partArea.setColumns(80);
        partArea.setLineWrap(true);
        partArea.setMaximumSize(new Dimension(50, 50));

        partArea.setEditable(false);
        constraints.fill = GridBagConstraints.BOTH;
        constraints.weightx = 100;
        constraints.weighty = 100;
        add(new JScrollPane(partArea), constraints, 0, 1, 2, 1, partPanel);

        return partPanel;
    }

    private JPanel sensorPanel() {

        GridBagLayout controlGrid = new GridBagLayout();
        GridBagConstraints constraints = new GridBagConstraints();
        JPanel sensorPanel = new JPanel(controlGrid, false);
        sensorPanel.setBorder(BorderFactory.createTitledBorder(Messages
                .getString("MNSRobotPanel.1")));

        Vector sensors = ((NNS) Robot.getSensor()).getSensors();
        sensorChecks = new JCheckBox[sensors.size()];
        sensorButtons = new JButton[sensors.size()];
        for (int a = 0; a < sensors.size(); a++) {
            JPanel singlePanel = new JPanel(new GridLayout(1, 2));
            BioSensor s = (BioSensor) sensors.get(a);
            System.out.println(s.getname());
            sensorChecks[a] = new JCheckBox(s.getname());
            sensorButtons[a] = new JButton("toggle");
            singlePanel.add(sensorChecks[a]);
            singlePanel.add(sensorButtons[a]);
            add(new JScrollPane(singlePanel), constraints, 0, a, 2, 1,
                    sensorPanel);
        }

        return sensorPanel;
    }

    private JPanel addControlPanel() {

        GridBagLayout controlGrid = new GridBagLayout();
        GridBagConstraints constraints = new GridBagConstraints();

        constraints.fill = GridBagConstraints.BOTH;
        constraints.weightx = 100;
        constraints.weighty = 0;

        JPanel cpanel = new JPanel(controlGrid, false);
        cpanel.setFont(MainFrame.CrideBFont);
        cpanel.setBorder(BorderFactory.createTitledBorder(Messages
                .getString("MNSRobotPanel.41")));

        GridBagLayout unitGrid = new GridBagLayout();
        GridBagConstraints unitconstraints = new GridBagConstraints();
        JPanel unitpanel = new JPanel(unitGrid, false);
        unitpanel.setFont(MainFrame.CrideBFont);
        unitpanel.setBorder(BorderFactory
                .createTitledBorder("Robot Constructors"));
        
        unitconstraints.weightx = 100;
        unitconstraints.weighty = 100;
        unitconstraints.fill = GridBagConstraints.BOTH;
        robotFileField = new JTextField(Messages.getString("MNSRobotPanel.12"));
        robotFileField.setFont(MainFrame.CrideNFont);
        robotFileField.setText(Messages.getString("MNSRobotPanel.12")); //$NON-NLS-1$
        robotFileField.setBorder(BorderFactory
                .createEtchedBorder(EtchedBorder.LOWERED));
        add(robotFileField, unitconstraints, 0, 0, 2, 1, unitpanel);

        unitconstraints.weightx = 100;
        unitconstraints.weighty = 0;
        unitconstraints.fill = GridBagConstraints.HORIZONTAL;

        rFileLoader = new JButton(Messages.getString("MNSRobotPanel.15")); //$NON-NLS-1$
        rFileLoader.setFont(MainFrame.CrideBFont);
        rFileLoader.setActionCommand(Messages.getString("MNSRobotPanel.16")); //$NON-NLS-1$
        rFileLoader.addActionListener(this);
        add(rFileLoader, unitconstraints, 0, 1, 1, 1, unitpanel);

        robotLoader = new JButton(Messages.getString("MNSRobotPanel.17")); //$NON-NLS-1$
        robotLoader.setFont(MainFrame.CrideBFont);
        robotLoader.setActionCommand(Messages.getString("MNSRobotPanel.18")); //$NON-NLS-1$
        robotLoader.addActionListener(this);
        add(robotLoader, unitconstraints, 1, 1, 1, 1, unitpanel);

        constraints.weightx = 100;
        add(unitpanel, constraints, 0, 0, 4, 2, cpanel);

        // ///////////////

        // ///////////////
        unitGrid = new GridBagLayout();
        unitconstraints = new GridBagConstraints();
        unitpanel = new JPanel(unitGrid, false);
        unitpanel.setFont(MainFrame.CrideBFont);
        unitpanel
                .setBorder(BorderFactory.createTitledBorder("Robot Starters:"));

        unitconstraints.weightx = 100;
        unitconstraints.weighty = 100;
        unitconstraints.fill = GridBagConstraints.BOTH;
        scriptFileField = new JTextField(Messages.getString("MNSRobotPanel.19"));
        scriptFileField.setFont(MainFrame.CrideNFont);
        scriptFileField.setText(Messages.getString("MNSRobotPanel.19")); //$NON-NLS-1$
        scriptFileField.setBorder(BorderFactory
                .createEtchedBorder(EtchedBorder.LOWERED));
        add(scriptFileField, unitconstraints, 0, 0, 2, 1, unitpanel);

        unitconstraints.weightx = 100;
        unitconstraints.weighty = 0;
        unitconstraints.fill = GridBagConstraints.HORIZONTAL;
        sFileLoader = new JButton(Messages.getString("MNSRobotPanel.22")); //$NON-NLS-1$
        sFileLoader.setFont(MainFrame.CrideBFont);
        sFileLoader.setActionCommand(Messages.getString("MNSRobotPanel.23")); //$NON-NLS-1$
        sFileLoader.addActionListener(this);
        add(sFileLoader, unitconstraints, 0, 1, 1, 1, unitpanel);

        scriptLoader = new JButton(Messages.getString("MNSRobotPanel.24")); //$NON-NLS-1$
        scriptLoader.setFont(MainFrame.CrideBFont);
        scriptLoader.setActionCommand(Messages.getString("MNSRobotPanel.25")); //$NON-NLS-1$
        scriptLoader.addActionListener(this);
        add(scriptLoader, unitconstraints, 1, 1, 1, 1, unitpanel);

        constraints.weightx = 100;
        add(unitpanel, constraints, 0, 3, 4, 2, cpanel);

        // scriptClear = new JButton(Messages.getString("MNSRobotPanel.26"));
        // //$NON-NLS-1$
        // scriptClear.setActionCommand(Messages.getString("MNSRobotPanel.27"));
        // //$NON-NLS-1$
        // scriptClear.addActionListener(this);
        // add(scriptClear, constraints, 3, 5, 1, 1, cpanel);
        // ////////////////

        // ////////////////
        unitGrid = new GridBagLayout();
        unitconstraints = new GridBagConstraints();
        unitpanel = new JPanel(unitGrid, false);
        unitpanel.setFont(MainFrame.CrideBFont);
        unitpanel.setBorder(BorderFactory.createTitledBorder("Direct Control"));

        unitconstraints.weightx = 100;
        unitconstraints.weighty = 100;
        unitconstraints.fill = GridBagConstraints.BOTH;
        commandField = new JTextField("Type Commands: ");
        commandField.setFont(MainFrame.CrideNFont);
        commandField.setText("Type Commands: "); //$NON-NLS-1$
        commandField.setBorder(BorderFactory
                .createEtchedBorder(EtchedBorder.LOWERED));
        add(commandField, unitconstraints, 0, 0, 1, 1, unitpanel);

        
        unitconstraints.weightx = 100;
        unitconstraints.weighty = 0;
        unitconstraints.fill = GridBagConstraints.HORIZONTAL;
        commandButton = new JButton("Command"); //$NON-NLS-1$
        commandButton.setFont(MainFrame.CrideBFont);
        commandButton.setActionCommand("command"); //$NON-NLS-1$
        commandButton.addActionListener(this);
        add(commandButton, unitconstraints, 0, 1, 1, 1, unitpanel);

        unitconstraints.weightx = 100;
        unitconstraints.weighty = 100;
        unitconstraints.fill = GridBagConstraints.BOTH;
        dialogField = new JTextField("Type Dialog to Alice");
        dialogField.setSize(unitpanel.getWidth(), unitpanel.getHeight());
        dialogField.setFont(MainFrame.CrideNFont);
        dialogField.setText("Type Dialog to Alice"); //$NON-NLS-1$
        dialogField.setBorder(BorderFactory
                .createEtchedBorder(EtchedBorder.LOWERED));
        add(dialogField, unitconstraints, 0, 2, 1, 1, unitpanel);


        unitconstraints.weightx = 100;
        unitconstraints.weighty = 0;
        unitconstraints.fill = GridBagConstraints.HORIZONTAL;
        dialogButton = new JButton("Speak"); //$NON-NLS-1$
        dialogButton.setFont(MainFrame.CrideBFont);
        dialogButton.setActionCommand("speak"); //$NON-NLS-1$
        dialogButton.addActionListener(this);
        add(dialogButton, unitconstraints, 0, 3, 1, 1, unitpanel);
        constraints.weightx = 100;
        constraints.weighty = 0;
        constraints.fill = GridBagConstraints.BOTH;
        add(unitpanel, constraints, 0, 5, 1, 4, cpanel);


        
        
        unitGrid = new GridBagLayout();
        unitconstraints = new GridBagConstraints();
        unitpanel = new JPanel(unitGrid, false);
        unitpanel.setFont(MainFrame.CrideBFont);
        unitpanel.setBorder(BorderFactory.createTitledBorder("Spectrum Analyzer"));
        DanceGenerator d = (DanceGenerator)Robot.getSensor().getSensor("dance");
        d.setAnalyzer(analyzer);
        d.getSynchronizer().add(analyzer);
        unitconstraints.weightx = 100;
        unitconstraints.weighty = 20;
        unitconstraints.fill = GridBagConstraints.BOTH;
        
        // create a spectrum analyzer
        //SpectrumAnalyzer analyzer = new SpectrumAnalyzer(12, 12);
       // analyzer.addMouseListener(this);
        GridBagConstraints gc = new GridBagConstraints();

        gc.weightx = 100;
        gc.weighty = 100;
        gc.gridx = 0;
        gc.gridy = 0;
        gc.fill = GridBagConstraints.BOTH;
        sidePanel.add(analyzer, gc);
        //pa.setVisible(true);
        analyzer.setVisible(true);
        analyzer.repaint();
        sidePanel.repaint();
        //add(analyzer, unitconstraints, 0, 0, 3, 1, unitpanel);
        

        constraints.weighty = 100;
        add(unitpanel, constraints, 0, 9, 1, 2, cpanel);
        return cpanel;

    }

    private void startNetClient() {
        netclient = new RobotClient(netArea, netmessage, robot);

    }

    private void startAliceModule() {
        aliceclient = new AliceBasedInterface(robot);
        aliceclient.addDisplay(commandArea);
        Robot.getSensor().addnnsModule(aliceclient);
        aliceclient.start();
    }

    public void add(Component c, GridBagConstraints gbc, int x, int y, int w,
            int h) {
        gbc.gridx = x;
        gbc.gridy = y;
        gbc.gridwidth = w;
        gbc.gridheight = h;
        getContentPane().add(c, gbc);
    }

    public void add(Component c, GridBagConstraints gbc, int x, int y, int w,
            int h, JPanel destination) {
        gbc.gridx = x;
        gbc.gridy = y;
        gbc.gridwidth = w;
        gbc.gridheight = h;
        destination.add(c, gbc);
    }

    public void showRobot(String message) {
        partArea.insert(message + '\n', 0);
    }

    public void showScript(String message) {
        partArea.insert(message + '\n', 0);
    }

    /**
     * Implementing the ActionListener
     */
    public void actionPerformed(ActionEvent e) {
        String comm = e.getActionCommand();
        // if (comm.equalsIgnoreCase(robotCreator.getActionCommand())) {
        // partArea.insert(Messages.getString("MNSRobotPanel.28"),0 );
        // //$NON-NLS-1$
        // partArea.insert(Messages.getString("MNSRobotPanel.29"), 0);
        // //$NON-NLS-1$
        // SwingUtilities.invokeLater(new Runnable()
        // {
        // public void run()
        // {
        // robot.wake();
        // }
        // });
        //
        // } else
        if (comm.equalsIgnoreCase(robotLoader.getActionCommand())) {
            if (currentFileOpener == null
                    || currentFileOpener.getDescriptor() == null) {
                robotFileField.setText(Messages.getString("MNSRobotPanel.30")); //$NON-NLS-1$
                partArea.insert(Messages.getString("MNSRobotPanel.31"), 0); //$NON-NLS-1$
            } else {
                SwingUtilities.invokeLater(new Runnable() {
                    public void run() {
                        robot.constructRobot(currentFileOpener.getDescriptor());
                        JOptionPane.showInternalMessageDialog(getContentPane(),
                                new String(Messages
                                        .getString("MNSRobotPanel.32"))); //$NON-NLS-1$
                    }
                });
                try {
                    partArea.append((currentFileOpener.getDescriptor())
                            .getCanonicalPath());
                    partArea.append(Messages.getString("MNSRobotPanel.33")); //$NON-NLS-1$
                } catch (IOException io) {

                }
            }
        } else if (comm.equalsIgnoreCase(scriptLoader.getActionCommand())) {
            if (currentFileOpener == null
                    || currentFileOpener.getDescriptor() == null) {
                scriptFileField.setText(Messages.getString("MNSRobotPanel.34")); //$NON-NLS-1$
                commandArea.append(Messages.getString("MNSRobotPanel.35")); //$NON-NLS-1$
                commandArea.append(Messages.getString("MNSRobotPanel.36")); //$NON-NLS-1$
            } else {
                SwingUtilities.invokeLater(new Runnable() {
                    public void run() {
                        robot.execScriptNow(currentFileOpener.getDescriptor());
                    }
                });
                try {
                    commandArea.append((currentFileOpener.getDescriptor())
                            .getCanonicalPath());
                    commandArea.append(Messages.getString("MNSRobotPanel.37")); //$NON-NLS-1$
                } catch (IOException io) {

                }
            }

        } else if (comm.equalsIgnoreCase(sFileLoader.getActionCommand())) {
            currentFileOpener = new OpenFile(this, scriptFileField, "./rbtrsc/");
        } else if (comm.equalsIgnoreCase(rFileLoader.getActionCommand())) {
            currentFileOpener = new OpenFile(this, robotFileField, "./bhvsrc/");
        } else if (comm.equalsIgnoreCase(connectButton.getActionCommand())) {

        } else if (comm.equalsIgnoreCase(whoButton.getActionCommand())) {
            SwingUtilities.invokeLater(new Runnable() {
                public void run() {
                    netclient.whoInquire();
                }
            });

        } else if (comm.equalsIgnoreCase(sendButton.getActionCommand())) {
            SwingUtilities.invokeLater(new Runnable() {
                public void run() {
                    netclient.sendMessage();
                }
            });

        } else if (comm.equalsIgnoreCase(fileButton.getActionCommand())) {

        } else if (comm.equalsIgnoreCase(quitButton.getActionCommand())) {

        } else if (comm.equalsIgnoreCase(whisperButton.getActionCommand())) {

        } else if (comm.equalsIgnoreCase(netinitButton.getActionCommand())) {
            netclient.startClient();
            Robot.getSensor().addnnsModule(netclient);

        } else if (comm.equalsIgnoreCase(this.dialogButton.getActionCommand())) {
            if (aliceclient == null) {
                startAliceModule();
            } else {
                aliceclient.actionPerformed(new ActionEvent(dialogButton,
                        dialogButton.hashCode(), dialogField.getText()));
                dialogField.setText("");
            }
        } else if (comm.equalsIgnoreCase(this.commandButton.getActionCommand())) {
            robot.execCommand(commandField.getText());
        } else if (comm.equalsIgnoreCase(this.aliceToggleButton
                .getActionCommand())) {

        }
    }

    // the listener to the robot
    private Robot robot;

    private RobotClient netclient;

    private AliceBasedInterface aliceclient = null;

    private JButton rFileLoader, robotLoader, robotCreator, sFileLoader,
            scriptLoader, scriptClear, netconect, commandButton,
            dialogButton;

    private JButton[] sensorButtons;

    private JCheckBox[] sensorChecks;

    private JButton connectButton, whoButton, quitButton, whisperButton,
            sendButton, fileButton, netinitButton, aliceToggleButton;

    private JTextArea partArea, commandArea, netArea, speechArea, 
                        sensorArea;

    private JTextField robotFileField, scriptFileField, netmessage,
            commandField, dialogField;

    public JTextField ipField;
    
    public JPanel sidePanel;

    protected FileDialog fileDialog;

    protected OpenFile currentFileOpener;

    protected Vector files;
    
    public static SpectrumAnalyzer analyzer = new SpectrumAnalyzer(12,12);
}