package monitors;
import java.awt.Component;
import java.awt.Container;
import java.awt.FileDialog;
import java.awt.Frame;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.SwingUtilities;

import mainframe.MIFrame;
import multitool.CRLMultihandler;
import multitool.MServer;
import multitool.MultiTool;
import multitool.ServerEvent;
import multitool.ServerListener;
/**
 * Created on Jan 7, 2004
 * 
 * @author nabhoth
 * 
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class MultiPanel extends MIFrame
		implements
			ActionListener,
			ServerListener {
	/**
	 *  
	 */
	public MultiPanel() {
		super(600, 350, "Basic Multi Robot Panel", true, false);
		Container contentPane = getContentPane();
		GridBagLayout mainGrid = new GridBagLayout();
		contentPane.setLayout(mainGrid);
		GridBagConstraints mainC = new GridBagConstraints();
		mainC.fill = GridBagConstraints.BOTH;

		GridBagLayout controlGrid = new GridBagLayout();
		GridBagConstraints constraints = new GridBagConstraints();
		mainC.weightx = 100;
		mainC.weighty = 100;
		JPanel serverPanel = new JPanel(controlGrid, false);
		serverPanel.setBorder(BorderFactory
				.createTitledBorder("Server Window"));
		add(serverPanel, mainC, 0, 0, 4, 2);
		serverArea = new JTextArea();
		serverArea.setEditable(false);
		constraints.fill = GridBagConstraints.BOTH;
		constraints.weightx = 100;
		constraints.weighty = 100;
		add(new JScrollPane(serverArea), constraints, 0, 0, 2, 1, serverPanel);
		
		controlGrid = new GridBagLayout();
		constraints = new GridBagConstraints();
		JPanel multiToolPanel = new JPanel(controlGrid, false);
		multiToolPanel.setBorder(BorderFactory
				.createTitledBorder("Multitool Window"));
		add(multiToolPanel, mainC, 5, 0, 4, 2);
		multiToolArea = new JTextArea();
		multiToolArea.setEditable(false);

		constraints.fill = GridBagConstraints.BOTH;
		constraints.weightx = 100;
		constraints.weighty = 100;
		add(new JScrollPane(multiToolArea), constraints, 0, 0, 2, 1,
				multiToolPanel);

		
		
		controlGrid = new GridBagLayout();
		constraints = new GridBagConstraints();
		JPanel cpanel = new JPanel(controlGrid, false);
		
		
		cpanel.setBorder(BorderFactory.createTitledBorder("Control Panel"));
		mainC.fill = GridBagConstraints.HORIZONTAL;
		mainC.weightx = 100;
		mainC.weighty = 0;
		add(cpanel, mainC, 0, 4, 10, 3);

			constraints.fill = GridBagConstraints.BOTH;
			constraints.weightx = 100;
			constraints.weighty = 100;
			GridBagLayout subGrid = new GridBagLayout();
			GridBagConstraints subconstraints = new GridBagConstraints();
			JPanel subpanel = new JPanel(subGrid, false);
			add(subpanel, constraints, 0, 0, 5, 2, cpanel);

			subconstraints.weightx = 100;
			subconstraints.weighty = 100;
			add(new JLabel("Robot Finder:"), subconstraints, 0, 0, 2, 1, subpanel);
			robotFileField = new JTextField();
			subconstraints.fill = GridBagConstraints.BOTH;
			robotFileField.setText("");
			add(robotFileField, subconstraints, 2, 0, 3, 1, subpanel);
			
			add(new JLabel(""), subconstraints, 0, 1, 3, 1, subpanel);
			robotSeeker = new JButton("R - Seek");
			robotSeeker.setActionCommand("robotseek");
			robotSeeker.addActionListener(this);
			add(robotSeeker, subconstraints, 3, 1, 1, 1, subpanel);
			robotRemover = new JButton("R - Connect");
			robotRemover.setActionCommand("robotconnect");
			robotRemover.addActionListener(this);
			add(robotRemover, subconstraints, 4, 1, 1, 1, subpanel);
			
			subGrid = new GridBagLayout();
			subconstraints = new GridBagConstraints();
			constraints.fill = GridBagConstraints.BOTH;
			constraints.weightx = 100;
			constraints.weighty = 100;
			subpanel = new JPanel(subGrid, false);
			add(subpanel, constraints, 0, 2, 5, 2, cpanel);

			subconstraints.fill = GridBagConstraints.BOTH;
			subconstraints.weightx = 100;
			subconstraints.weighty = 100;

			add(new JLabel("Script Starter:"), subconstraints, 0, 0, 2, 1, subpanel);
			scriptFileField = new JTextField();
			scriptFileField.setText("");
			add(scriptFileField, subconstraints, 2, 0, 3, 1, subpanel);
			add(new JLabel(""), subconstraints, 0, 1, 2, 1, subpanel);
			scriptLoader = new JButton("Load Script");
			scriptLoader.setActionCommand("loadScript");
			scriptLoader.addActionListener(this);
			add(scriptLoader, subconstraints, 2, 1, 1, 1, subpanel);
			sFileProcessor = new JButton("Parse Script");
			sFileProcessor.setActionCommand("procesScript");
			sFileProcessor.addActionListener(this);
			add(sFileProcessor, subconstraints, 3, 1, 1, 1, subpanel);
			scriptRunner = new JButton("Run Script");
			scriptRunner.setActionCommand("runScript");
			scriptRunner.addActionListener(this);
			add(scriptRunner, subconstraints, 4, 1, 1, 1, subpanel);
			
			
			subGrid = new GridBagLayout();
			subconstraints = new GridBagConstraints();
			constraints.fill = GridBagConstraints.BOTH;
			constraints.weightx = 100;
			constraints.weighty = 100;
			subpanel = new JPanel(subGrid, false);
			add(subpanel, constraints, 0, 4, 5, 2, cpanel);

			subconstraints.weightx = 100;
			subconstraints.weighty = 0;
			add(new JLabel("Sever Control:"), constraints, 0, 0, 2, 1, subpanel);
			scriptFileField = new JTextField();
			scriptFileField.setText("");add(scriptFileField, constraints, 2, 0, 3, 1, subpanel);
			add(new JLabel(""), constraints, 0, 1, 3, 1, subpanel);
			serverOn = new JButton("Server Start");
			serverOn.setActionCommand("startServer");
			serverOn.addActionListener(this);
			add(serverOn, constraints, 3, 1, 1, 1, subpanel);
			serverOff = new JButton("Server Stop");
			serverOff.setActionCommand("stopServer");
			serverOff.addActionListener(this);
			add(serverOff, constraints, 4, 1, 1, 1, subpanel);
	}
	/*
	 * (non-Javadoc)
	 * 
	 * @see multitool.ServerListener#load(multitool.ServerEvent)
	 */
	public void load(ServerEvent evt) {
		String comm = evt.getActionCommand();
		serverArea.insert(comm + "\n", 0);
	}
	/**
	 * @param c
	 * @param gbc
	 * @param x
	 * @param y
	 * @param w
	 * @param h
	 */
	public void add(Component c, GridBagConstraints gbc, int x, int y, int w,
			int h) {
		gbc.gridx = x;
		gbc.gridy = y;
		gbc.gridwidth = w;
		gbc.gridheight = h;
		getContentPane().add(c, gbc);
	}
	/**
	 * @param c
	 * @param gbc
	 * @param x
	 * @param y
	 * @param w
	 * @param h
	 * @param destination
	 */
	public void add(Component c, GridBagConstraints gbc, int x, int y, int w,
			int h, JPanel destination) {
		gbc.gridx = x;
		gbc.gridy = y;
		gbc.gridwidth = w;
		gbc.gridheight = h;
		destination.add(c, gbc);
	}
	/**
	 * @param message
	 */
	public void showRobot(String message) {
		serverArea.append(message + "/n");
		serverArea.setCaretPosition(serverArea.getText().length());
	}
	/**
	 * @param message
	 */
	public void showScript(String message) {
		multiToolArea.append(message + "/n");
		multiToolArea.setCaretPosition(multiToolArea.getText().length());
	}
	/**
	 * Implementing the ActionListener
	 */
	public void actionPerformed(ActionEvent e) {
		String comm = e.getActionCommand();
		if (comm.equalsIgnoreCase(robotSeeker.getActionCommand())) {
		} else if (comm.equalsIgnoreCase(robotRemover.getActionCommand())) {
		} else if (comm.equalsIgnoreCase(scriptLoader.getActionCommand())) {
			currentFileOpener = new OpenFile(scriptFileField);
		} else if (comm.equalsIgnoreCase(scriptRunner.getActionCommand())) {
			if (currentFileOpener == null) {
				scriptFileField.setText("");
				multiToolArea.append("First select a file");
				multiToolArea.setCaretPosition(multiToolArea.getText().length());
			}
			SwingUtilities.invokeLater(new Runnable() {
				public void run() {
					goMethod();
				}
			});
		} else if (comm.equalsIgnoreCase(sFileProcessor.getActionCommand())) {
			if (currentFileOpener == null) {
				scriptFileField.setText("");
				multiToolArea.append("First select a file");
				multiToolArea.setCaretPosition(multiToolArea.getText().length());
			}
			SwingUtilities.invokeLater(new Runnable() {
				public void run() {
					if (multiTool != null) {
						File f = currentFileOpener.getDescriptor();
						multiTool.process(f);
					} else
						multiToolArea.append(
								"Server must be started first! \n");
					multiToolArea.setCaretPosition(multiToolArea.getText().length());
				}
			});
		} else if (comm.equalsIgnoreCase("parser done")) {
			multiTool.sendFiles();
			multiToolArea.append("Main file parsed: ready to start! \n");
			multiToolArea.setCaretPosition(multiToolArea.getText().length());
		} else if (comm.equalsIgnoreCase(serverOn.getActionCommand())) {
			SwingUtilities.invokeLater(new Runnable() {
				public void run() {
					serverOnMethod();
				}
			});
		} else if (comm.equalsIgnoreCase(serverOff.getActionCommand())) {
			
		} else if (e.getSource() instanceof MultiTool) {
			multiToolArea.append(comm + "\n");
			multiToolArea.setCaretPosition(multiToolArea.getText().length());
		} else if (e.getSource() instanceof CRLMultihandler) {
			multiToolArea.append(comm + "\n");
			multiToolArea.setCaretPosition(multiToolArea.getText().length());
		}
	}
	/**
	 *  
	 */
	public void goMethod() {
		multiToolArea.append("Starting! \n");
		multiToolArea.setCaretPosition(multiToolArea.getText().length());
		multiTool.executeGroupScript();
	}
	/**
	 *  
	 */
	public void serverOnMethod() {
		new MServer(this);
		multiTool = new MultiTool(this);
		multiTool.addClient();
	}
	/**
	 * @author martin lukac
	 *  
	 */
	class OpenFile {
		public OpenFile(JTextField destin) {
			this.destin = destin;
			Frame frame = null;
			for (Container p = getParent(); p != null; p = p.getParent()) {
				if (p instanceof Frame) {
					frame = (Frame) p;
					break;
				}
			}
			if (fileDialog == null) {
				fileDialog = new FileDialog(frame);
				fileDialog.setSize(700, 500);
			}
			fileDialog.setMode(FileDialog.LOAD);
			fileDialog.setVisible(true);
			String file = fileDialog.getFile();
			if (file == null) {
				return;
			}
			String directory = fileDialog.getDirectory();
			currentFile = new File(directory, file);
			if (currentFile.exists()) {
				destin.setText(currentFile.getName());
			} else
				destin.setText("The file does not exists");
		}
		public File getDescriptor() {
			return currentFile;
		}
		private File currentFile;
		private JTextField destin;
	}
	private JButton robotSeeker, robotRemover, sFileProcessor, scriptLoader,
			scriptRunner, serverOn, serverOff;
	private JTextArea serverArea, multiToolArea;
	private JTextField robotFileField, scriptFileField;
	protected FileDialog fileDialog;
	protected OpenFile currentFileOpener;
	private MultiTool multiTool = null;
}