/************************************************************************
 * 
 * Created on Nov 30, 2005
 * Package monitors
 * Filename OpenFile.java
 * 
 ************************************************************************/

//***********************************************************************
//																		*
// Martin Lukac, 2003-2005 												*
// Intelligent Robotics Laboratory										*
// Portland State University 											*
// Office: 70-08 FAB, phone: 503-490-8478								*
// Mail:	P.O. Box 751												*
//			Portland, OR 97207-0751										*
// Email:	lukacm@cecs.pdx.edu											*
// Updates and documentation: 	www.pdx.edu\~lukacm						*
// **********************************************************************
//
//			*********************************************
//			*********************************************
// This program is provided WITHOUT ANY WARRANTY either expressed
// or implied.  You may study, use, modify, and distribute it for
// any non-commercial purposes.  For any commercial use, prior 
// permission from the authors must be granted.
// 			*********************************************
//			*********************************************

package monitors;

import java.awt.Container;
import java.awt.FileDialog;
import java.awt.Frame;
import java.io.File;

import javax.swing.JTextField;

import mns.Messages;


class OpenFile {

	private final MNSRobotPanel panel;
    public OpenFile(MNSRobotPanel panel, JTextField destin, String destination) {
		this.destin = destin;
        this.panel = panel;
		this.destination = destination;
		Frame frame = null;
		for (Container p = panel.getParent(); p != null; p = p.getParent()) {
			if (p instanceof Frame) {
				frame = (Frame) p;
				break;
			}
		}

		if (this.panel.fileDialog == null) {
			this.panel.fileDialog = new FileDialog(frame);
			this.panel.fileDialog.setSize(700, 500);
		}
		this.panel.fileDialog.setMode(FileDialog.LOAD);
		this.panel.fileDialog.setVisible(true);
		String file = this.panel.fileDialog.getFile();

		if (file == null) {
			return;
		}
		String directory = this.panel.fileDialog.getDirectory();
		currentFile = new File(directory, file);

		if (currentFile.exists()) {
			destin.setText(currentFile.getName());
		} else destin.setText(Messages.getString("MNSRobotPanel.40")); //$NON-NLS-1$
	}
	
	public File getDescriptor(){
		
		return currentFile;
	}
	
	private File currentFile;
	private JTextField destin;
	private String destination;
}