package monitors;

import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.util.Vector;

import javax.swing.AbstractAction;
import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSlider;
import javax.swing.JTextArea;
import javax.swing.JViewport;
import javax.swing.border.EtchedBorder;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import mainframe.MIFrame;
import mns.MNS;
import mns.MNSEvent;
import devs.speechpackage.SpeechGenerator;
import devs.speechpackage.SpeechRecognizer;

/*
 * Created on Jan 7, 2004
 *
 */

/**
 * @author nabhoth
 *
 * 
 */
public class SpeechPanel extends MIFrame implements ActionListener{
	
	public SpeechPanel(MNS mns){
		super(600, 300, "Voice Panel", true, false);
		
		Vector devices = mns.getDevices();
		SpeechPanel.sgenerator = (SpeechGenerator)devices.firstElement();
		
		if (devices.get(1) instanceof SpeechRecognizer)
			SpeechPanel.srecognizer = (SpeechRecognizer)devices.get(1);
		
		Container contentPane = getContentPane();
		GridBagLayout mainGrid = new GridBagLayout();
		contentPane.setLayout(mainGrid);
		GridBagConstraints mainC = new GridBagConstraints();
		mainC.fill = GridBagConstraints.BOTH;
		int totalX = 0;
		int totalY = 0;
		
		//Setting the main Label
		JLabel label =
			new JLabel(
					"",
					javax.swing.plaf.metal.MetalIconFactory.getTreeComputerIcon(),
					JLabel.CENTER);
		mainC.weightx = 100;
		mainC.weighty = 0;
		mainC.fill = GridBagConstraints.HORIZONTAL;
		mainC.anchor = GridBagConstraints.NORTH;
		add(label, mainC, totalX, totalY, 20, 1);
		label.setBorder(BorderFactory.createTitledBorder("Speech Control Panel"));
		
		
		mainC.weightx = 100;
		mainC.weighty = 100;
		mainC.fill = GridBagConstraints.BOTH;
		mainC.anchor = GridBagConstraints.NORTH;
		
		add(addSynthPanel(), mainC, totalX, totalY+1, 10, 8);
		add(addRecogPanel(), mainC, totalX+10, totalY+1, 10, 8);

	}
	
	private JPanel addSynthPanel()
	{
		// add the synthesis panel
		int boxY = 0;
		int boxX = 0;
		JPanel devPanel = new JPanel();
		GridBagConstraints devC = new GridBagConstraints();
		GridBagLayout devG = new GridBagLayout();
		devPanel.setLayout(devG);
		devPanel.setBorder(BorderFactory.createTitledBorder("Synthesis Control Panel"));
		
		String[] voiceS = sgenerator.getVoices();
		devC.weightx = 0;
		devC.weighty = 0;
		devC.fill = GridBagConstraints.BOTH;
		devC.anchor = GridBagConstraints.NORTH;
		JComboBox combo = new JComboBox();
		combo.setName("Voices");
		combo.addItemListener(new ItemListener(){
			
			public void itemStateChanged(ItemEvent evt) {
				JComboBox cb = (JComboBox)evt.getSource();
				
				// Get the affected item
				Object item = evt.getItem();
				
				if (evt.getStateChange() == ItemEvent.SELECTED) {
				    String [] a = new String [2];
				    a[0] = "v";
				    a[1] = (String)item;
					SpeechPanel.sgenerator.load(new MNSEvent(a));
				} else if (evt.getStateChange() == ItemEvent.DESELECTED) {
					// Item is no longer selected
				}
			}
		});
		int q = voiceS.length;
		for (int m = 0; m < q; m++) {
			combo.addItem(voiceS[m]);
		}
		combo.setEditable(false);
		add(devPanel, combo, devC, boxX, boxY, 1, 1);

		boxY += 1;
		
		
		//add sliders for voice control
		JSlider slider;
		JPanel panel;
		JLabel label;
		for (int b = 0; b < 3; b++) {
			if (b == 0) {
				label = new JLabel("Volume", JLabel.LEFT);
				slider = createJSlider(60, 100, "Volume");
			} else if (b == 1) {
				label = new JLabel("Pitch", JLabel.LEFT);
				slider = createJSlider(-50, 100, "Pitch");
			} else {
				label = new JLabel("Rate", JLabel.LEFT);
				slider = createJSlider(0, 200, "Rate");
			}
			
			
			slider.addChangeListener(new ChangeListener() {
				public void stateChanged(ChangeEvent evt) {
					JSlider slider = (JSlider) evt.getSource();
					
					if (!slider.getValueIsAdjusting()) {
						if ( slider.getName().equalsIgnoreCase("volume")){
							float value =(float) slider.getValue();
							String [] a = new String[2];
							a[0] = "m";
							a[1] = Float.toString(value);
							SpeechPanel.sgenerator.load(new MNSEvent(a));
						} else if ( slider.getName().equalsIgnoreCase("Pitch")){
							float value =(float) slider.getValue();
							String [] a = new String[2];
							a[0] = "p";
							a[1] = Float.toString(value);
							SpeechPanel.sgenerator.load(new MNSEvent(a));
						} else {
							float value =(float) slider.getValue();
							String [] a = new String[2];
							a[0] = "r";
							a[1] = Float.toString(value);
							SpeechPanel.sgenerator.load(new MNSEvent(a));
						}
					}
				}
			});
			panel = new JPanel();
			GridLayout G = new GridLayout(1,2);
			panel.setLayout(G);
			panel.add(label);
			panel.add(slider);
			
			devC.weighty = 0;
			devC.weightx = 100;
			devC.fill = GridBagConstraints.HORIZONTAL;
			panel.setBorder(
					BorderFactory.createEtchedBorder(EtchedBorder.LOWERED));
			add(devPanel, panel, devC, boxX, boxY + b, 1, 1);
		}
		
		boxY += 3;
		
		label = new JLabel("Test ");
		devC.weighty = 100;
		devC.weightx = 100;
		devC.fill = GridBagConstraints.BOTH;
		add(devPanel, label, devC, boxX, boxY, 1, 1);
		
		boxY += 1;
		
		JTextArea com = new JTextArea();
		JButton speechtest = new JButton("Speak");
		speechtest.setActionCommand("stest");
		speechtest.addActionListener(new AbstractAction(){
			public void actionPerformed(ActionEvent e){
				try{
					String textTS = "Hello this is the interactive voice controller";
							SpeechPanel.sgenerator.speakLine(textTS);
				}catch(Exception ex){
					ex.printStackTrace();
				}

			}
		});
//		com.setFont(new Font("Serif", Font.PLAIN, 10));
//		com.setLineWrap(true);
//		com.setWrapStyleWord(true);
//		com.getDocument().addDocumentListener(new DocumentListener(){
//			
//			
//			public void changedUpdate(DocumentEvent evt){
//			}
//			
//			public void removeUpdate(DocumentEvent evt){
//			}
//			
//			public void insertUpdate(DocumentEvent evt){
//			}
//			
//		});
//
//		com.setEditable(true);
		devC.weighty = 100;
		devC.weightx = 50;
		devC.fill = GridBagConstraints.VERTICAL;
		add(devPanel, speechtest, devC, boxX, boxY, 1, 1);
		
		return devPanel;
	}
	
	private JPanel addRecogPanel()
	{
		
		int boxY = 0;
		int boxX = 0;
		JPanel devPanel = new JPanel();
		GridBagConstraints devC = new GridBagConstraints();
		GridBagLayout devG = new GridBagLayout();
		devPanel.setLayout(devG);
		devPanel.setBorder(BorderFactory.createTitledBorder("Synthesis Control Panel"));
		
		
		
		devPanel.setBorder(BorderFactory.createTitledBorder("Recognition Panel"));
		boxY = 0;
		devC.weightx = 0;
		devC.weighty = 0;
		devC.fill = GridBagConstraints.VERTICAL;
		devC.anchor = GridBagConstraints.NORTH;
		

		
		JLabel label = new JLabel("Volume", JLabel.LEFT);
		JSlider slider = createJSlider(0, 100, "Volume");
			
		slider.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent evt) {
				JSlider slider = (JSlider) evt.getSource();
					
				if (!slider.getValueIsAdjusting()) {
					if ( slider.getName().equalsIgnoreCase("volume")){
						float value =(float) slider.getValue();
						//SpeechPanel.sgenerator.setVolume(value);
					}
				}
			}
		});
		GridLayout gl = new GridLayout(1,2);
		JPanel panel = new JPanel(gl, false);
		GridBagLayout G = new GridBagLayout();
		panel.add(label);
		panel.add(slider);
		devC.weighty = 0;
		devC.weightx = 100;
		devC.fill = GridBagConstraints.HORIZONTAL;
		panel.setBorder(
				BorderFactory.createEtchedBorder(EtchedBorder.LOWERED));
		add(devPanel, panel, devC, boxX, boxY , 1, 1);

		
		boxY += 1;

		label = new JLabel("Recognizer output: ");
		devC.weighty = 0;
		devC.weightx = 100;
		devC.fill = GridBagConstraints.BOTH;
		devC.anchor = GridBagConstraints.NORTH;
		add(devPanel, label, devC, boxX, boxY, 1, 1);
		
		boxY += 1;
		
		JScrollPane scroller = new JScrollPane();
		
		JTextArea com = new JTextArea();
		com.setRows(25);
		com.setEditable(false);
		com.setCaretColor(Color.RED);
		com.setLineWrap(false);
		com.setFont(Font.decode("SYSTEM").deriveFont((float)10));
		com.setText("Main Bio messages");


	    JScrollPane scroll = new JScrollPane(com);
		scroll.setVerticalScrollBarPolicy(
				JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		scroll.setPreferredSize(new Dimension(250, 250));
		com.setEditable(true);
		devC.weighty = 100;
		devC.weightx = 100;
		devC.fill = GridBagConstraints.BOTH;
		devC.anchor = GridBagConstraints.NORTH;
		scroll.setBorder(
				BorderFactory.createEtchedBorder(EtchedBorder.RAISED));
		add(devPanel, scroll, devC, boxX, boxY, 1, 6);

		return devPanel;		
	}
	
	public void add(
			Component c,
			GridBagConstraints gbc,
			int x,
			int y,
			int w,
			int h) {
		gbc.gridx = x;
		gbc.gridy = y;
		gbc.gridwidth = w;
		gbc.gridheight = h;
		getContentPane().add(c, gbc);
	}
	
	public void add(
			Container cont,
			Component c,
			GridBagConstraints gbc,
			int x,
			int y,
			int w,
			int h) {
		gbc.gridx = x;
		gbc.gridy = y;
		gbc.gridwidth = w;
		gbc.gridheight = h;
		cont.add(c, gbc);
	}
	
	/**
	 * Creating JSlider
	 * @param min - min value
	 * @param max - max value
	 * @param name - name of the JSlider
	 * @return the JSlider
	 */
	protected JSlider createJSlider(int min, int max, String name) {
		
		JSlider slider = new JSlider(min, max);
		slider.setName(name);
		// Determine if currently showing ticks
		boolean b = slider.getPaintTicks(); // false
		
		// Show tick marks
		slider.setPaintTicks(true);
		
		int size = max-min;
		// Set major tick marks every 25 units
		slider.setMajorTickSpacing((size/3));
		// Set minor tick marks every 5 units
		slider.setMinorTickSpacing((size/30));
		
		//slider.se
		slider.setPaintLabels(true);
		
		return slider;
	}
	
	/**
	 * Implementing the ActionListener
	 */
	public void actionPerformed(ActionEvent e) {
		String name = e.getActionCommand();
		if (name.equalsIgnoreCase("close")) {
			try {
				//this.setClosed(true);
			} catch (Exception ev) {
			}
		} else if (name.equalsIgnoreCase("stest")) {
			try {
				//this.setClosed(true);
			} catch (Exception ev) {
			}
		}
	}
	private JViewport port;

	
	//the listener to the robot
	private static SpeechGenerator sgenerator = null;
	//the listener to the robot
	private static SpeechRecognizer srecognizer = null;
}

