package mns;
import java.util.EventListener;
/**
 * * Created on Jan 1, 2004

 * @author Martin Lukac 
 * 
 * 				This is the basis of each Meta-Device such as Speech
 *               Movement, Sensors, Vision, In short it is just a functional
 *               implementation of an interface however to force the subsequent code
 *               all abstract methods must be implemented in the devices in order to
 *               provide a common command interface
 */

public interface BioDevice extends MNSListener, EventListener {

	/**
	 *  simple interface to control all Devices
	 */
	public void load(MNSEvent cnE);
	
	/**
	 * @param cnE
	 */
	public void loadCNTR(MNSEvent cnE);
	
	/**
	 * @param rP
	 */
	public void addListener(BioDeviceListener rP);
	
	/**
	 * @return
	 */
	public int getCurrentPosition();
	
	/**
	 * @return
	 */
	public int getCurrentState();
	
	/**
	 * @return 
	 */
	public String getControls();
	
	/**
	 * @return
	 */
	public String getname();
	
	
	/** state declaration */
	final static public int DONE = 0;
	/**Robot Part is temporarily paused */
	final static public int PAUSED = 1;
	/**Robot Part finnished*/
	final static public int END = 2;
	/**Inidicator of the fact that at least one Cycling command is active*/
	final static public int CYCLING = 3;
	/**Robot Part is being initiatedt*/
	final static public int START = 4;
	/**RobotPart is processing some commands*/
	final static public int BUSY = 5;
	/**Robot Part is resumed */
	final static public int RESUMED = 6;
	/**Robot Part is blocked somewhere */
	final static public int BLOCKED = 7;
	/**Robot Part is waiting */
	final static public int WAIT = 8;
	
}
