/*
 * Created on Feb 26, 2004
 *
 */
package mns;

import java.util.EventObject;

/**
 * @author martin lukac
 *
 * Event Generated (in some cases) by the BioDevice.
 */
public class BioDeviceEvent extends EventObject {

	/**
	 * implementation of BioDevice Events, the lowest events, closest
	 * to the hardware implementations.
	 * 
	 * @param source - source of the event
	 * @param state - state of the source
	 */
	public BioDeviceEvent(Object source, int state) {
		super(source);
		this.state = state;
	}

	/**
	 * implementation of BioDevice Events, the lowest events, closest
	 * to the hardware implementations.
	 * 
	 * @param source - source of the event
	 * @param state - state of the source
	 */
	public BioDeviceEvent(Object source, Object data) {
		super(source);
		this.data = data;
	}

	public int getState(){
		return state;
	}
	public Object getData(){
	    return data;
	}
	
	private int state = 0;

	private Object data = null;
}
