/************************************************************************
 * Created on Jul 20, 2004
 * 	This program is provided WITHOUT ANY WARRANTY either expressed 		*
 *	or implied.  You may study, use, modify, and distribute it for 		*
 *	any non-commercial purposes.  For any commercial use, prior 		*
 *	permission from the author must be granted.							*
 *	? Martin Lukac, 2003-2004 Created on Jan 22, 2004				*
 *	Intelligent Robotics Laboratory										*
 *	Portland State University 											*
 *	Office: 70-08 FAB, phone: 503-725-2783							*
 *	Mail:	P.O. Box 751												*
 *			Portland, OR 97207-0751										*
 *	Email:	lukacm@ece.pdx.edu										*
 *	Updates and documentation: 	www.pdx.edu\~lukacm			*
 ************************************************************************/
package mns;

import java.util.MissingResourceException;
import java.util.ResourceBundle;

/**
 * @author Martin Lukac
 *
 * This is a part of mns package
 */
public class Commands {
    private static final String         BUNDLE_NAME     = "mns.commands";                //$NON-NLS-1$

    private static final ResourceBundle RESOURCE_BUNDLE = ResourceBundle
                                                                .getBundle(BUNDLE_NAME);

    private Commands() {
    }

    public static String getCommand(String key) {
        // TODO Auto-generated method stub
        try {
            return RESOURCE_BUNDLE.getString(key);
        } catch (MissingResourceException e) {
            return null;
        }
    }
}