package multitool;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintWriter;
import java.util.Vector;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;
/**
 * Created on Mar 22, 2004
 * 
 * @author Martin Lukac
 *  
 */
public class CRLMultihandler extends DefaultHandler {
	/**
	 * 
	 *  
	 */
	public CRLMultihandler() {
		MultiFiles = new Vector();
	}
	/**
	 * @param f
	 */
	public CRLMultihandler(File f) {
		MultiFiles = new Vector();
	}
	/*
	 * (non-Javadoc)
	 * 
	 * @see org.xml.sax.ContentHandler#endDocument()
	 */
	public void endDocument() throws SAXException {
		super.endDocument();
	}
	/*
	 * (non-Javadoc)
	 * 
	 * @see org.xml.sax.ContentHandler#startDocument()
	 */
	public void startDocument() throws SAXException {
		super.startDocument();
		MultiFiles = new Vector();
		counter = 0;
	}
	/*
	 * (non-Javadoc)
	 * 
	 * @see org.xml.sax.ContentHandler#startElement(java.lang.String,
	 *      java.lang.String, java.lang.String, org.xml.sax.Attributes)
	 */
	public void startElement(String namespaceURI, String lname, String qname,
			Attributes attrs) {
		if (qname.trim().equalsIgnoreCase("crl")) {
			showComm("<:> Script File opened correctly <:>");
		} else if (qname.trim().equalsIgnoreCase("robot")) {
			robotBegin = true;
			destination = "robot";
			commandBegin = false;
		} else if (destination != "robot") {
			if (qname.trim().equalsIgnoreCase("sync")) {
				commandBegin = true;
				commandName = "sync";
				synchro = true;
			} else if (qname.trim().equalsIgnoreCase("wait")) {
				commandBegin = true;
				commandName = "wait";
			} else
				System.out.print(qname);
		} else {
			if (qname.trim().equalsIgnoreCase("sync"))
				pW.write("<" + qname.trim() + ">" + '\n');
			else
				pW.write("<" + qname.trim() + ">");
			commandBegin = true;
		}
	}
	/*
	 * (non-Javadoc)
	 * 
	 * @see org.xml.sax.ContentHandler#endElement(java.lang.String,
	 *      java.lang.String, java.lang.String)
	 */
	public void endElement(String namespaceURI, String lname, String qname) {
		if (qname.trim().equalsIgnoreCase("crl")) {
			showComm("<:> Script File closed correctly <:>");
			listener.actionPerformed(new ActionEvent(this, this.hashCode(),
					"parser done"));
		} else if (qname.trim().equalsIgnoreCase("robot")) {
			robotBegin = false;
			destination = null;
			pW.write("</crl>" + '\n');
			pW.close();
		} else if (destination == null) {
			if (qname.trim().equalsIgnoreCase("sync")) {
				commandBegin = false;
				commandName = null;
				synchro = false;
			} else if (qname.trim().equalsIgnoreCase("wait")) {
				commandBegin = false;
				commandName = null;
			} else {
				pW.write("</" + qname.trim() + ">" + '\n');
				commandBegin = false;
			}
		} else {
			pW.write("</" + qname.trim() + ">" + '\n');
			commandBegin = false;
		}
	}
	/*
	 * (non-Javadoc)
	 * 
	 * @see org.xml.sax.ContentHandler#characters(char[], int, int)
	 */
	public void characters(char ch[], int start, int length) {
		// get the value of within tag
		String temp = "";
		for (int i = start; i < start + length; i++) {
			temp = temp + ch[i];
		}
		temp = temp.trim();
		if (robotBegin && destination == "robot" && !commandBegin
				&& temp.length() > 0) {
			try {
				mFile = new MultiFile("robot" + counter + ".crl");
				mFile.setDest("robot" + temp);
				showComm("Script for " + mFile.getDest()
						+ " is being generated");
				MultiFiles.add(mFile);
				if (synchro)
					mFile.setsynchro(true);
				counter++;
				pW = new PrintWriter(new FileOutputStream((File) mFile));
				pW.write("<crl>" + '\n');
			} catch (FileNotFoundException e) {
				e.printStackTrace();
			}
		}
		if (temp != null && temp.length() > 0 && commandBegin != false)
			pW.write(temp);
		else if (temp != null && temp.length() > 0) {
			mFile.setdestination(Integer.parseInt(temp));
			//showComm(Integer.toString(mFile.getdestination()));
		}
	}
	/**
	 * @param listener
	 */
	public CRLMultihandler(ActionListener listener) {
		MultiFiles = new Vector();
		this.listener = listener;
	}
	/**
	 * @param m
	 */
	private void showComm(String m) {
		if (listener != null)
			listener.actionPerformed(new ActionEvent(this, this.hashCode(), m));
		else
			System.out.println(m);
	}
	/**
	 * @param node
	 * @param pW
	 */
	public void writeCRL(Node node, PrintWriter pW) {
		this.pW = pW;
		write(node, "\t");
	}
	/**
	 * @param node
	 * @param indent
	 */
	private void write(Node node, String indent) {
		switch (node.getNodeType()) {
			case Node.DOCUMENT_NODE :
				{
					pW.println(indent + "<?xml version='1.0'?>");
					NodeList list = node.getChildNodes();
					int a = 0;
					while (a < list.getLength()) {
						write((Node) list.item(a), indent);
					}
				}
		}
	}
	/**
	 * @return all saved scripts for robots
	 */
	public Vector getScripts() {
		return this.MultiFiles;
	}
	//writer
	private PrintWriter pW;
	//the multiFile it selfS
	private MultiFile mFile;
	//the counter for building parts of robot
	private int stageCounter = 0;
	//sections defined by tags
	private boolean robotBegin = false;
	private boolean commandBegin = false;
	//the collection of MultiRobotfiles to be sent ot the robot community
	private Vector MultiFiles;
	//to construct a robot we need some templates
	//and some milestones -- hardcoded
	private String destination = null;
	private String commandName = null;
	private int counter = 0;
	//params for file processing
	private boolean synchro = false;
	//event triggered comm
	protected ActionListener listener = null;
}