package multitool;
import java.io.File;
import java.io.PrintWriter;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;
import org.xml.sax.helpers.DefaultHandler;
/**
 * Created on Jan 11, 2004
 *  
 * @author Martin Lukac
 * 
 * parser exclusively used to read and write a robot from/to a CRL file later
 * on this might be specified by a .dtd file
 */
public class CRLSAXParser extends Thread {
	/**
	 * default constructor
	 */
	public CRLSAXParser() {
		super();
		//fetch a SAX parser
		SAXParserFactory factory = SAXParserFactory.newInstance();
		try {
			parserSAX = factory.newSAXParser();
		} catch (Exception t) {
			t.printStackTrace();
		}
		start();
	}
	/**
	 * @param handler
	 */
	public CRLSAXParser(DefaultHandler handler) {
		super();
		//fetch a SAX parser
		SAXParserFactory factory = SAXParserFactory.newInstance();
		try {
			parserSAX = factory.newSAXParser();
		} catch (Exception t) {
			t.printStackTrace();
		}
		this.handler = handler;
		start();
	}
	/**
	 * First of two methods running this self starting threade class It parses
	 * the fille and constructs a robot
	 * 
	 * @param file -
	 *                   file to parse
	 */
	synchronized public void process(File file) {
		inputFile = file;
		interrupt();
	}
	/**
	 * change the current handler
	 * 
	 * @param handler -
	 *                   the new handler
	 */
	public void chngHandler(DefaultHandler handler) {
		this.handler = handler;
	}
	/**
	 * overriden as form Thread
	 */
	public void run() {
		while (true) {
			try {
				synchronized (this) {
					while (true) {
						try {
							wait(1000);
						} catch (InterruptedException intr) {
							break;
						}
					}
					if (parserSAX != null && inputFile != null)
						parserSAX.parse(inputFile, handler);
				}
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	}
	//for multiple parsings of a file let's keep it in the memory
	private File inputFile = null;
	////The handler of teh sax parser - the DTD handler
	private DefaultHandler handler = null;
	//The factory yahooooooo - using the SAX method
	private SAXParserFactory factorySAX = null;
	//The factory for DOM models
	private DocumentBuilderFactory factoryDOM = null;
	//The parser it self
	private SAXParser parserSAX = null;
	//writer
	private PrintWriter fW = null;
}