package nns;

import mns.BioDevice;
import mns.BioDeviceListener;
import mns.MNSEvent;
import biocell.BioThread;

 /*
 * 	This program is provided WITHOUT ANY WARRANTY either expressed 		*
 *	or implied.  You may study, use, modify, and distribute it for 		*
 *	any non-commercial purposes.  For any commercial use, prior 		*
 *	permission from the author must be granted.							*
 *	? Martin Lukac, 2003-2004 Created on Jan 22, 2004				*
 *	Intelligent Robotics Laboratory										*
 *	Portland State University 											*
 *	Office: 70-08 FAB, phone: 503-725-2783							*
 *	Mail:	P.O. Box 751												*
 *			Portland, OR 97207-0751										*
 *	Email:	lukacm@ece.pdx.edu										*
 *	Updates and documentation: 	www.pdx.edu\~lukacm			*
 ************************************************************************/

/**
 * 
 * @author martin lukac
 * 
 * The Class encapsuating all sensory function in the robot, 
 * wether they are software or hooked to some hardware device
 * such as network adapter, camera or microphone
 *
 */
public class BioSensor extends BioThread implements BioDevice{
	/* (non-Javadoc)
	 * @see mns.BioDevice#addListener(mns.BioDeviceListener)
	 */
	public void addListener(BioDeviceListener rP) {
		// TODO Auto-generated method stub

	}
	/* (non-Javadoc)
	 * @see mns.BioDevice#getControls()
	 */
	public String getControls() {
		// TODO Auto-generated method stub
		return null;
	}
	/* (non-Javadoc)
	 * @see mns.BioDevice#seState(int)
	 */
	public void seState(int State) {
		this.State = State;

	}
	/* (non-Javadoc)
	 * @see mns.MNSListener#process(mns.MNSEvent)
	 */
	public void process(MNSEvent cnv) {
	}
	/* (non-Javadoc)
	 * @see mns.BioDevice#addListener(mns.BioDeviceListener)
	 */
	public void addListener(BioSensorListener listener) {
		this.listener = listener;
	}
	/* (non-Javadoc)
	 * @see mns.BioDevice#getCurrentPosition()
	 */
	public int getCurrentPosition() {
		return 0;
	}
	/* (non-Javadoc)
	 * @see mns.BioDevice#getCurrentState()
	 */
	public int getCurrentState() {
		return this.State;
	}
	/* (non-Javadoc)
	 * @see mns.BioDevice#load(mns.MNSEvent)
	 */
	public void load(MNSEvent cnE) {
	}
	/* (non-Javadoc)
	 * @see mns.BioDevice#loadCNTR(mns.MNSEvent)
	 */
	public void loadCNTR(MNSEvent cnE) {
	}

	/**
	 * @param n
	 */
	public void addSensorListener(BioSensorListener n) {
		listener = n;
	}

	/**
	 * @return Returns the listener.
	 */
	public synchronized BioSensorListener getListener() {
		return listener;
	}
	/**
	 * @param listener The listener to set.
	 */
	public synchronized void setListener(BioSensorListener listener) {
		this.listener = listener;
	}
	   /**
     * @param portName
     */
    public BioSensor(int Type, String portName) {
        super(portName);
        setname(portName);
        setType(Type);
    }
    
    /**
     * @return Returns the type.
     */
    public int getType() {
        return type;
    }
    /**
     * @param type The type to set.
     */
    public void setType(int type) {
        this.type = type;
    }
	/**
	 * Comment for <code>EXTERO_SENSOR</code>
	 */
	public static final int EXTERO_SENSOR = 0;
	/**
	 * Comment for <code>INTERO_SENSOR</code>
	 */
	public static final int INTERO_SENSOR = 1;
	/**
	 * Comment for <code>PROPRIO_SENSOR</code>
	 */
	public static final int PROPRIO_SENSOR = 2;
	
	private int type;
	
	private int State;
	
	private String name;
	
	/**
	 * @return Returns the name.
	 */
	public synchronized String getname() {
		return name;
	}
	/**
	 * @param name The name to set.
	 */
	public synchronized void setname(String name) {
		this.name = name;
	}
	private BioSensorListener listener;
}