/*
 * Created on Jul 29, 2004
 *
 */
package nns;

import mainframe.Tools;

/**
 * @author martin lukac
 *
 * This is a simple class representing a simple implication logic rule
 * The class behaves as a simple storage unit and comparator so as
 * we can input either another rule for comparison, another String 
 * for comparison and/or String to be interpreted.
 * Each rule is held in two parts: the if statement and the then statement;
 * If statement is the part used to decode a query by match or not match
 * the ELSE statement is the part to be returned and represents a valid
 * command that can be fed directly to the moto--neuron center as a reflex
 * or a simple command.
 * 
 * To generate a simple logic rule the syntax is exactly the same as the
 * simplified if-else statement: CONDITION ? EXECUTE IF TRUE : EXECUTE IF FALSE
 * The evaluation has two possible settings: STRICT or RELAXED.
 * STRICT  forces an exact match of the condition to the submited statement (AND condition)
 * RELAXED compares the statement element by element to the condition and if a single 
 * argument is equal returns TRUE and appropriate action (OR statement) 
 * CONDITION, EXECUTE IF TRUE and EXECUTE IF FALSE are in the MNS/NNS syntax
 */
public class BioSensorRule implements Comparable{

    /* (non-Javadoc)
     * @see java.lang.Comparable#compareTo(java.lang.Object)
     */
    public int compareTo(Object o) {
        if (o instanceof BioSensorRule)
            return 1;
        else if (o instanceof String){
            return analyzeRule(o);
        } else return 0;
    }

    public int analyzeRule(Object o){
        String [] s = Tools.tokenize((String)o);
        
        
        return 0;
    }

    /**
     * @param o - object in the MNS command format
     * @return - object in the MNS syntax
     */
    public String analyzeStatement(Object o){
        String [] stat = Tools.tokenize((String)o, "*");
        String [] cond = Tools.tokenize(ifStatement, "*");
        
        try {
            
        }catch (Exception e){
            
        }
        
        return null;
    }

    public BioSensorRule(String rule){
        super();
        ifStatement = (rule.substring(rule.indexOf('?'))).trim();
        trueStatement = (rule.substring(rule.indexOf('?')+1, rule.indexOf(':'))).trim();
        falseStatement = (rule.substring(rule.indexOf(':'))).trim();
    }
    
    private String ifStatement;
    private String trueStatement;
    private String falseStatement;
    
    
}
