/*
 * Created on Jul 10, 2004
 *
 */
package biocell;

import java.lang.Thread.State;

import mns.BioDevice;
import monitors.CommCenter;

/**
 * @author Martin Lukac
 * This describes one of the wrappers for various functions.
 * It allows to connect to Dynamic mood, 
 * Energy and Strategy Calculator so as provide a formated way 
 * to communicate with the Bio level of the robot
 * 
 */
public class BioCell extends Object {

	public BioCell(String name) {
		//super(name);
		CommCenter.showBioData("BioDevice "+name+" created");
		//generate a new mood for this object
		currentmood = new DynamicMood("normal");
		//initiate the mood space for this agent
		currentmood.setdependency(name);
		//initiate the energy on it self
		energy = new Energy(this);
		energy.energyModified(new EnergyPrimitive(name));
	}

	/* (non-Javadoc)
	 * @see java.lang.Thread#getState()
	 */
	public int getstate() {
		// TODO Auto-generated method stub
		State s =  State.RUNNABLE;
		if (s == State.NEW){
			return BioDevice.START;
		} else if (s == State.RUNNABLE){
			return BioDevice.CYCLING;
		} else if (s == State.BLOCKED){
			return BioDevice.BLOCKED;
		} else if (s == State.WAITING){
			return BioDevice.WAIT;
		} else if (s == State.TIMED_WAITING){
			return BioDevice.WAIT;
		} else if (s == State.TERMINATED){
			return BioDevice.DONE;
		} else return BioDevice.START;
	}

	/**
	 * @param name
	 * @return
	 */
	public double getMoodParam(String name){
		double result = currentmood.getParameter(name);
		if (result == -100)
			return 1;
		else
			return result;
	}
	
	/**
	 * @param name - reset the mood to one of the initially encoded
	 */
	public void setMood(String name){
		String dep = currentmood.dependency;
		currentmood.setTemplateMood(name);
		currentmood.setdependency(dep);
	}
	
	/**
	 * @return Returns the currentmood.
	 */
	synchronized public DynamicMood getCurrentmood() {
		return currentmood;
	}
	

	public void stepEnergy(Object o) {
		this.energy.energyModified(new EnergyPrimitive(o));
	}
	

	/**
	 * Comment for <code>energy</code>
	 */
	private EnergyPrimitivesListener energy = null;
	
	private DynamicMood currentmood = null;

	//this is the relay to the energy
	private EnergyPrimitivesListener listener = null;

}