/*
 * Created on Feb 27, 2005
 *
 */
package biocell;

import mns.BioDevice;
import monitors.CommCenter;


/**
 * @author martin lukac
 * 
 * Thread based bio-wrapper, provdes 
 * synchronized access to moods and updates 
 * the parameters similalrly to BioCell
 * 
 */
public class BioThread extends Thread{

	/**
	 * @param name
	 */
	public BioThread(String name) {
		super(name);
		CommCenter.showBioData("BioDevice "+name+" created");
		//generate a new mood for this object
		currentmood = new DynamicMood("normal");
		//initiate the mood space for this agent
		currentmood.setdependency(name);
		//initiate the energy on it self
		energy = new Energy(this);
		energy.energyModified(new EnergyPrimitive(name));
	}
	
	/* (non-Javadoc)
	 * @see java.lang.Thread#getState()
	 */
	public int getstate() {
		// TODO Auto-generated method stub
		State s =  super.getState();
		if (s == State.NEW){
			return BioDevice.START;
		} else if (s == State.RUNNABLE){
			return BioDevice.CYCLING;
		} else if (s == State.BLOCKED){
			return BioDevice.BLOCKED;
		} else if (s == State.WAITING){
			return BioDevice.WAIT;
		} else if (s == State.TIMED_WAITING){
			return BioDevice.WAIT;
		} else if (s == State.TERMINATED){
			return BioDevice.DONE;
		} else return BioDevice.START;
	}
	/**
	 * @param name
	 * @return
	 */
	public double getMoodParam(String name){
		double result = currentmood.getParameter(name);
		if (result == -100)
			return 1;
		else
			return result;
	}
	
	/**
	 * @param name - reset the mood to one of the initially encoded
	 */
	public void setMood(String name){
		String dep = currentmood.dependency;
		currentmood.setTemplateMood(name);
		currentmood.setdependency(dep);
	}
	
	/**
	 * the current pointer to mood <code>currentmood</code>
	 */
	private DynamicMood currentmood = null;
	
	/**
	 * @return Returns the currentmood.
	 */
	synchronized public DynamicMood getCurrentmood() {
		return currentmood;
	}
	

	public void stepEnergy(Object o) {
		this.energy.energyModified(new EnergyPrimitive(o));
	}
	
	public BioThread(){
		
	}
	

	private EnergyPrimitivesListener energy = null;
}