/*
 * Created on Aug 16, 2005
 *
 */
package biocell;

/**
 * @author martin lukac
 *
 * Energy Primitive - simple object encoding in the Energy terms.
 * Simple way how to handle the signals transformed to energy values
 * 
 */
public class EnergyPrimitive {

	/**
	 * 
	 */
	public EnergyPrimitive(Object o) {
		if (o == null)
			this.name = "noname";
		else 
			this.name = o.toString();

		if (o instanceof Double){
		value = Double.parseDouble(o.toString());
		} else if (o instanceof String){
			byte [] temp = ((String)o).getBytes();
			int result = 0;
			for (int m = 0 ; m < temp.length; m++)
					result= (result+temp[m])%256;
			value = (double)(result)/256;
		} else value = Math.random();
	}

	/**
	 * @param value
	 * @param name
	 */
	public EnergyPrimitive(double value, String name) {
		this.value = value;
		this.name = name;
	}
	
	/**
	 * @return Returns the hash.
	 */
	public double getHash() {
		return hash;
	}
	/**
	 * @return Returns the name.
	 */
	public String getName() {
		return name;
	}
	/**
	 * @return Returns the value.
	 */
	public double getValue() {
		return value;
	}
	private double value;
	private double hash;
	private String name;
}
