/*
 * Created on Feb 27, 2005
 *
 * It is a simple implementation of a BioCell in the same sense
 * as every other object. It maps on the first level all states of the
 * device. It the next step a deeper emotion mapping will be generated as the result
 * of adding more code physically
 */
package biocell;

import java.io.BufferedReader;
import java.io.DataInputStream;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Iterator;
import java.util.Vector;

import monitors.CommCenter;
import qinterface.qBrain;


/**
 * @author nabhoth
 *
 * The Energy based managment system facility. It accepts moods as representations of the
 * BioModules such as BioThread or BioCell
 * 
 */  
public  class GlobalState extends BioThread{
	
	/* (non-Javadoc)
	 * @see biocell.MoodListener#modified()
	 */
	public static void modified() {
		//FIXME generate the call to update the energy and parameters

	}
	public GlobalState(){
		GlobalState.generateMoods();
		brain = new qBrain("Mood Brain");
		
	}
	
	/**
	 * generates moods from the default file
	 */
	public static void generateMoods() {

		DynamicMood dn = null;

		// Open the file that is the first
		// command line parameter
		try {
			FileInputStream fstream;
			try {
				fstream = new FileInputStream("robot/biocell/moods");
			}catch (FileNotFoundException e){
					fstream = new FileInputStream("biocell/moods");
			}

			// Convert our input stream to a
			// DataInputStream
			DataInputStream in = new DataInputStream(fstream);
			 BufferedReader d
	          = new BufferedReader(new InputStreamReader(in));
			moods = new Vector(1, 1);

			// Continue to read lines while
			// there are still some left to read
			//while (in.available() != 0) {
			String line = null;
			while ((line = d.readLine()) != null) {
				// Print file line to screen
				//String line = d.readLine();
				if (line.charAt(0) == ':') {
					dn = new DynamicMood();
					dn.setname(line.substring(1));
					moods.add(dn);
				} else if (dn != null) {
					String name = line.substring(0, line.indexOf(' '));
					double val = Double.parseDouble(line.substring(line.indexOf(' ')));
					dn.addParameter(name , val );
				}
			}
			in.close();
			CommCenter.showBioData("Moods generated: "+moods.size());
		} catch (IOException e) {
			CommCenter.showBioData("problem creating moods: " + e.getMessage());
			e.printStackTrace();
		}
	}

	/**
	 * initialize the global mood - the mood mnager
	 */
	public static void iniMainMood(){
		if(globalMood == null){
			globalMood = new ZeroMood("normal");
			globalMood.setdependency("Global State controller");
		}
		CommCenter.showBioData("global state actif :"+currentMoods.size());
		CommCenter.showBioData("global state default :"+moods.size());
	}
	/**
	 * @param o - remove object to the energy based managment system.
	 */
	synchronized  public void unregister(DynamicMood o){
		Iterator i = GlobalState.currentMoods.iterator();
		while(i.hasNext()){
			DynamicMood dn = (DynamicMood)i.next();
			if (o.equals(dn)){
				GlobalState.currentMoods.remove(dn);
				break;
			}
		}
		CommCenter.showBioData("The current number of running bio processes is: "+GlobalState.currentMoods.size());
		notifyAll();
	}
	/**
	 * @param name - generate single template mood
	 */
	public static synchronized void setTemplateMood(String name){
		DynamicMood template = null;
		for (int a = 0; a < moods.size(); a++) {
			if (((DynamicMood) moods.get(a)).bioname.equalsIgnoreCase(name))
				template = (DynamicMood) moods.get(a);
		if (template != null)	
		for (a = 1; a < currentMoods.size(); a++) {
			DynamicMood d = (DynamicMood) currentMoods.get(a);
			d.cleanParameter();
			d.setName(template.getname());
				Vector init = template.getParameters(0);
				for (int n = 0; n < init.size(); n++){
					MoodParam p = (MoodParam)init.get(n);
					d.addParameter(p.getn(), p.getv());
				}
			}
		}
	}

	/* (non-Javadoc)
	 * @see biocell.MoodListener#update(biocell.DynamicMood)
	 */
	synchronized static public void update() {
		for (int a = 0; a < currentMoods.size(); a++){
		}
	}

	/**
	 * @param o
	 */
	synchronized private static void addMoods(DynamicMood o){
		moods.add(o);
	}
	

	/**
	 * @return Returns the currentMoods.
	 */
	public static  Vector getCurrentMoods() {
		return currentMoods;
	}
	/**
	 * @param currentMoods The currentMoods to set.
	 */
	public static synchronized void setCurrentMoods(Vector currentMoods) {
		GlobalState.currentMoods = currentMoods;
	}
	/**
	 * @return Returns the globalMood.
	 */
	public static  DynamicMood getGlobalMood() {
		return globalMood;
	}
	/**
	 * @param globalMood The globalMood to set.
	 */
	public static synchronized void setGlobalMood(DynamicMood globalMood) {
		GlobalState.globalMood = globalMood;
	}
	
	/**
	 * @return
	 */
	public static double getFood(){
		//FIXME repair this
		return 1;
	}
	
	/**
	 * @return Returns the moods.
	 */
	public static  Vector getMoods() {
		return moods;
	}
	/**
	 * @param moods The moods to set.
	 */
	public static synchronized void setMoods(Vector moods) {
		GlobalState.moods = moods;
	}
	/**
	 * @return Returns the classesAttributes.
	 */
	public synchronized Vector getClassesAttributes() {
		return classesAttributes;
	}

	static public synchronized void addCurrentMood(DynamicMood d){
		currentMoods.add(d);
		CommCenter.showBioData("new active mood added :"+currentMoods.size());
		CommCenter.showBioData("active state moods :"+currentMoods.size());
	}

	static public synchronized void delCurrentMood(DynamicMood d){
		currentMoods.remove(d);
		CommCenter.showBioData("active mood removed :"+currentMoods.size());
		CommCenter.showBioData("active state moods :"+currentMoods.size());
	}

	/**
	 * @param classesAttributes The classesAttributes to set.
	 */
	public synchronized void setClassesAttributes(Vector classesAttributes) {
		this.classesAttributes = classesAttributes;
	}
	
	/**
	 * Comment for <code>moods</code>
	 */
	public static Vector moods = new Vector(1);
	
	/**
	 * Comment for <code>globalMood</code>
	 */
	public static DynamicMood globalMood = null;
	/**
	 * Comment for <code>currentMoods</code>
	 */
	static public Vector currentMoods = new Vector(1);
	
	/**
	 * Comment for <code>classesAttributes</code>
	 */
	private Vector classesAttributes = new Vector(1);
	
	private qBrain brain;
}
