/*
 * Created on Apr 4, 2005
 * 
 * The register of all possible moods with regards to a neccessary-evil
 * classification
 */
package biocell;

/**
 * @author martin lukac
 * 
 * A subclass of DynamicMood representing all other moods for global evaluation and evaluator
 */

import java.util.Vector;

import monitors.BioDataFrame;
public class ZeroMood extends DynamicMood {

	//parameters for various parts of the robot. later to be exported
	//all is in double in range [0,1]
	//all numbers are only ratios and percentages. They are to be the
	// result of more
	//elaborate strategy to generate behaviors in space and time
	//TODO change to interval [-1,1]

	/**
	 * @param name
	 */
	public ZeroMood(String name) {
		super(name);
		start();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.lang.Runnable#run()
	 */
	public void run() {
		parameters = new Vector();
		energies = new Vector();
		strategies = new Vector();
		double[] params = new double[getArrayPredictor(0).length];
		double[] energs = new double[getArrayPredictor(0).length];
		double[] strats = new double[getArrayPredictor(0).length];
		energy = 1;
		strategy = 1;
		while (true) {
			//CommCenter.showBioData("updating all moods0");
			synchronized (this) {
				//CommCenter.showBioData("updating all moods1");
				try {
					wait(500);
				} catch (Exception e) {
					e.printStackTrace();
				}
				//CommCenter.showBioData("updating all moods2");

				Vector moods = GlobalState.getCurrentMoods();
				double [][]disp = new double[moods.size()][2];
				
				for (int a = 1; a < moods.size(); a++) {
					energs[a] = ((DynamicMood) moods.get(a))
							.getParameter("energy");
					disp[a][0] = energs[a];
					energy += energs[a];
					strats[a] = ((DynamicMood) moods.get(a))
							.getParameter("strategy");
					disp[a][1] = strats[a];
					strategy += strats[a];
				}

				energy /= energs.length;
				strategy /= strats.length;

//				System.out.println("Zero Mood Energy: "+energy+" Strategy: "+strategy);
				double radius = moods.size();
				if (energy >= Double.MAX_VALUE || energy <= Double.MIN_VALUE){
				    energy = moods.size();
				    strategy = moods.size();
				}
				//evaluate the global state of energy levels
				if (radius > 1) {
					//CommCenter.showBioData("updating all moods");
					energy = (Math.exp(-Math.pow(energy - radius / 2, 2)) / (2 * Math
							.pow(radius * 5, 2)));
					strategy = Math.sqrt((strategy * strategy)
							+ Math.pow((radius - strategy), 2));

					//modify the energy of all moods
					//also here is on eof possible anchor points for the
					// quantum query
				}
				disp[0][0] = energy;
				disp[0][1] = strategy;
				if(display != null)
					display.Add(disp);
				for (int a = 0; a < moods.size(); a++) {
					((DynamicMood) moods.get(a)).setParameter("energy", energy+((DynamicMood) moods.get(a))
							.getParameter("energy"));
					((DynamicMood) moods.get(a)).setParameter("strategy",
							strategy);
				}

			}
		}
	}

	
	/**
	 * @return Returns the display.
	 */
	public synchronized BioDataFrame getDisplay() {
		return display;
	}
	
	/**
	 * @param display The display to set.
	 */
	public synchronized void setDisplay(BioDataFrame display) {
	    if (this.display != null)
	        this.display = null;
		this.display = display;
	}
	
	
	private BioDataFrame display;
	
	private Vector parameters;

	private Vector energies;

	private Vector strategies;

	//thisis only temporary
	// all should be executed in one time step via run()
	private double energy;

	private double strategy;
}
